import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;
import javax.swing.*;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.*;
import javax.swing.border.*;
//import RaveTableModel;

public class RaveDefaultRowHeaderRenderer extends JLabel implements TableCellRenderer {
    public Color defaultColor = new Color(240,240,0);
    private RaveTableSorter rtm;
    private Color backgroundColor;
 
    public Component getTableCellRendererComponent(JTable table, Object value,
    boolean isSelected, boolean hasFocus, int row, int column) {
        setText(value.toString());
        setOpaque(true);
        setBackground(defaultColor);
        setHorizontalAlignment(this.CENTER);
       
        Container viewer = table.getParent();
        Container spane = viewer.getParent();
        JViewport ravetableview = (JViewport)spane.getComponent(0);
        JTable ravetable = (JTable)ravetableview.getComponent(0);
        
        int modelrow = row;
           
        this.rtm = (RaveTableSorter)ravetable.getModel();
        try{ //next line gives null pointer exception sometimes... not sure why. row out of bounds of model?
            modelrow = this.rtm.modelIndex(row); //get model row in case of sorting
        }catch(Exception e){
            
        }
        
        int rowColor = this.rtm.getRowColor(modelrow);
        
        Color[] colorSpecs = this.rtm.getRowColorSpecs();
        backgroundColor = colorSpecs[rowColor];
        
        setBackground(backgroundColor);
        setBorder(BorderFactory.createMatteBorder(0, 5, 0, 5, backgroundColor));
        
        int R = backgroundColor.getRed();
        int G = backgroundColor.getGreen();
        int B = backgroundColor.getBlue();
        double a = (0.299 * R + 0.587 * G + 0.114*B) / 255 ;
         
        if(a < 0.5){
            setForeground(Color.white);
        }else{
            setForeground(Color.black);
        }
             
        return this;
  
    }
   
    
    public boolean isOpaque() {
        return true;
    }
       
    public void validate() {}
    public void revalidate() {}
    public void repaint(long tm, int x, int y, int width, int height) {}
    public void repaint (Rectangle r) {}
    protected void firePropertyChange(String propertyName, Object oldValue, Object newValue) {} 
    public void firePropertyChange(String propertyName, boolean oldValue, boolean newValue) {} 
       
}