function bgblobsubax_callback(src,eventdata)
%default bgblob callback for graphs that use subaxes

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
uicontrol(handles.dummyobj)

bgblobs=findobj(handles.tabobjects,'tag','bgblob');
set(bgblobs,'value',0);
set(src,'value',1);

newidx=get(src,'userdata');
udata.format.bg=newidx;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%get colors:
axescolors=handles.colors.axes{newidx};
fgcolor=axescolors(1,:);
bgcolor=axescolors(2,:);
lightgrid=axescolors(3,:);
stronggrid=axescolors(4,:);
txt=axescolors(5,:);


%change colors
set(handles.subfakerax{handles.activeindex},'color',bgcolor,'xcolor',lightgrid,'ycolor',lightgrid)
set(handles.subfakeax{handles.activeindex},'xcolor',stronggrid,'ycolor',stronggrid);
set(handles.subax{handles.activeindex},'xcolor',fgcolor,'ycolor',fgcolor,'zcolor',fgcolor);

xticklabel=findall(handles.subax{handles.activeindex},'type','text','tag','xticklabel');
yticklabel=findall(handles.subax{handles.activeindex},'type','text','tag','yticklabel');
zticklabel=findall(handles.subax{handles.activeindex},'type','text','tag','zticklabel');

set([xticklabel;yticklabel;zticklabel],'color',txt);

xlab=get(handles.subax{handles.activeindex},'xlabel');
ylab=get(handles.subax{handles.activeindex},'ylabel');
zlab=get(handles.subax{handles.activeindex},'zlabel');

ax=[xlab;ylab;zlab];
if iscell(ax);
    ax=cell2mat(ax);
end

set(ax,'color',txt);


