function raveenablezoombars(src,ev)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

if isfield(udata.explore,'zoombars')
    if isfield(udata.explore.zoombars,'ax')
        if ishandle(udata.explore.zoombars.ax)
            delete(udata.explore.zoombars.ax);
        end
    end
end

if ~ismember('zoombars',udata.explore.method);return;end %make zoombars

%make axes:
pos=get(handles.activegraph,'position');
ax=axes('units','pixels','position',pos+[0 0 10 10],'parent',handles.wspanel,'color','none',...
    'xlim',[0 pos(3)+10],'ylim',[0 pos(4)+10],'visible','off','tag','',...
    'userdata',handles.activeindex,'hittest','off');

%     line([0 pos(3)],[pos(4)+6 pos(4)+6],'parent',ax,'linewidth',0.5,'color',[.5 .5 .5],...
%         'marker','none','tag','xzoomline','userdata',get(ax,'xlim'));
%     line([pos(3)+6 pos(3)+6],[0 pos(4)],'parent',ax,'linewidth',0.5,'color',[.5 .5 .5],...
%         'marker','none','tag','yzoomline','userdata',get(ax,'ylim'));
%

tricolor=[175 106 172]./255;
barcolor=[210 196 212]./255;


xbar=line([0 pos(3)],[pos(4)+6 pos(4)+6],'linewidth',7,'marker','none','hittest','on',...
    'color',barcolor,...
    'buttondownfcn',@zoombar,'parent',ax,'tag','xbar');

xlow=line(3,pos(4)+6,'linewidth',1,'marker','>','hittest','on',...
    'markerfacecolor',tricolor,'markersize',6,'markeredgecolor',[.2 .2 .2],...
    'buttondownfcn',@zoomdragger,'parent',ax,'tag','xlow');
xhigh=line(pos(3)-3,pos(4)+6,'linewidth',1,'marker','<','hittest','on',...
    'markerfacecolor',tricolor,'markersize',6,'markeredgecolor',[.2 .2 .2],...
    'buttondownfcn',@zoomdragger,'parent',ax,'tag','xhigh');

ybar=line([pos(3)+6 pos(3)+6],[0 pos(4)],'linewidth',7,'marker','none','hittest','on',...
    'color',barcolor,...
    'buttondownfcn',@zoombar,'parent',ax,'tag','ybar');

ylow=line(pos(3)+6,3,'linewidth',1,'marker','^','hittest','on',...
    'markerfacecolor',tricolor,'markersize',6,'markeredgecolor',[.2 .2 .2],...
    'buttondownfcn',@zoomdragger,'parent',ax,'tag','ylow');
yhigh=line(pos(3)+6,pos(4)-3,'linewidth',1,'marker','v','hittest','on',...
    'markerfacecolor',tricolor,'markersize',6,'markeredgecolor',[.2 .2 .2],...
    'buttondownfcn',@zoomdragger,'parent',ax,'tag','yhigh');
udata.explore.zoombars.ax=ax;
udata.explore.zoombars.deletehandles=ax;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%make sure zoombars reflect current zoom state:

xlim=get(handles.activegraph,'xlim');
ylim=get(handles.activegraph,'ylim');

%pos=get(ax,'pos');

%get max limits:
maxxlim=udata.format.xlim;

normxlim=(xlim-maxxlim(1))./(maxxlim(2)-maxxlim(1));

%convert to positions:
relxlim=normxlim.*(pos(3)-6)+3;

set(xlow,'xdata',relxlim(1));
set(xhigh,'xdata',relxlim(2));
set(xbar,'xdata',relxlim+[-3 3]);


%get max limits:
maxylim=udata.format.ylim;

normylim=(ylim-maxylim(1))./(maxylim(2)-maxylim(1));

%convert to positions:
relylim=normylim.*(pos(4)-6)+3;

set(ylow,'ydata',relylim(1));
set(yhigh,'ydata',relylim(2));
set(ybar,'ydata',relylim+[-3 +3]);



function zoomdragger(src,ev)
handles=guidata(src);
uistack(src,'top'); %important: this prevents the filter from getting stuck under the opposing filter.

switch get(src,'tag')
    case {'xlow','xhigh'}
        set(handles.fig,'windowbuttonmotionfcn',{@zoomxslide,src})
    case {'ylow','yhigh'}
        set(handles.fig,'windowbuttonmotionfcn',{@zoomyslide,src})
end

set(handles.fig,'windowbuttonupfcn',{@zoomdone,src})

function zoomxslide(fig,eventdata,src) %#ok<INUSL>
handles=guidata(fig);
ax=get(src,'parent');
ai=get(ax,'userdata');

udata=get(handles.fakeax(ai),'userdata');

clicked=get(ax,'currentpoint');
val=clicked(1,1);

%move marker within bounds
pos=get(ax,'position');
lims=[3 pos(3)-13];
switch get(src,'tag')
    case 'xlow'
        lims(2)=get(findobj(ax,'tag','xhigh'),'xdata');
    case 'xhigh'
        lims(1)=get(findobj(ax,'tag','xlow'),'xdata');
end

if val>lims(2)
    val=lims(2);
elseif val<lims(1)
    val=lims(1);
end

set(gco,'xdata',val)
xbar=findobj(ax,'tag','xbar');
xd=get(xbar,'xdata');
switch get(src,'tag')
    case 'xlow'
        xd(1)=val;
    case 'xhigh'
        xd(2)=val;
end

set(xbar,'xdata',xd);

%do zooming:
xlim=udata.format.xlim;
xr=xlim(2)-xlim(1);

rellow=(xd(1)-3)./(pos(3)-16);
relhigh=(xd(2)-3)./(pos(3)-16);

newxlim=xlim(1)+xr.*[rellow relhigh];
axez=[handles.allgraphs(ai) handles.fakeax(ai) handles.fakerax(ai)];
try
    set(axez,'xlim',single(newxlim));
end

if ismember('alwaysrotatexticks',udata.attributes);
    ar=true;
else
    ar=false;
end
ravemovecustomticks(handles.activegraph,[],ar);




function zoomyslide(fig,eventdata,src) %#ok<INUSL>
handles=guidata(fig);
ax=get(src,'parent');
ai=get(ax,'userdata');

udata=get(handles.fakeax(ai),'userdata');

clicked=get(ax,'currentpoint');
val=clicked(1,2);

%move marker within bounds
pos=get(ax,'position');
lims=[3 pos(4)-13];
switch get(src,'tag')
    case 'ylow'
        lims(2)=get(findobj(ax,'tag','yhigh'),'ydata');
    case 'yhigh'
        lims(1)=get(findobj(ax,'tag','ylow'),'ydata');
end

if val>lims(2)
    val=lims(2);
elseif val<lims(1)
    val=lims(1);
end

set(gco,'ydata',val)
ybar=findobj(ax,'tag','ybar');
yd=get(ybar,'ydata');
switch get(src,'tag')
    case 'ylow'
        yd(1)=val;
    case 'yhigh'
        yd(2)=val;
end

set(ybar,'ydata',yd);

%do zooming:
ylim=udata.format.ylim;
yr=ylim(2)-ylim(1);

rellow=(yd(1)-3)./(pos(4)-16);
relhigh=(yd(2)-3)./(pos(4)-16);

newylim=ylim(1)+yr.*[rellow relhigh];
axez=[handles.allgraphs(ai) handles.fakeax(ai) handles.fakerax(ai)];

try
    set(axez,'ylim',single(newylim));
end

if ismember('alwaysrotatexticks',udata.attributes);
    ar=true;
else
    ar=false;
end
ravemovecustomticks(handles.activegraph,[],ar);



function zoomdone(fig,eventdata,src) %#ok<INUSL>
handles=guidata(fig);
set(handles.fig,'windowbuttonmotionfcn',@ravedefaultwindowbuttonmotionfcn)
set(handles.fig,'windowbuttonupfcn','')



function zoombar(src,ev)
handles=guidata(src);

set(0,'userdata',get(gca,'currentpoint'));
guidata(src,handles);

switch get(src,'tag')
    case {'xbar'}
        set(handles.fig,'windowbuttonmotionfcn',{@zoomxbar,src})
    case {'ybar'}
        set(handles.fig,'windowbuttonmotionfcn',{@zoomybar,src})
end
set(handles.fig,'windowbuttonupfcn',{@zoomdone,src})

function zoomxbar(src,ev,xbar)
handles=guidata(src);
ax=gca;
ai=get(ax,'userdata');
udata=get(handles.fakeax(ai),'userdata');


clicked=get(ax,'currentpoint');
val=clicked(1,1);

lastclicked=get(0,'userdata');
lastval=lastclicked(1,1);
set(0,'userdata',clicked);
deltaval=(val-lastval)./2;
xdata=get(gco,'xdata');
xdata=xdata+deltaval;

%move marker within bounds
pos=get(ax,'position');
lims=[3 pos(3)-13];

if xdata(2)+deltaval>lims(2)
    deltaval=lims(2)-xdata(2);
elseif xdata(1)+deltaval<lims(1)
    deltaval=lims(1)-xdata(1);
end

xd=xdata+deltaval;

set(gco,'xdata',xd)

xlow=findobj(ax,'tag','xlow');
xhigh=findobj(ax,'tag','xhigh');

set(xlow,'xdata',xd(1));
set(xhigh,'xdata',xd(2));

%do zooming:
xlim=udata.format.xlim;
xr=xlim(2)-xlim(1);

rellow=(xd(1)-3)./(pos(3)-16);
relhigh=(xd(2)-3)./(pos(3)-16);

newxlim=xlim(1)+xr.*[rellow relhigh];
axez=[handles.allgraphs(ai) handles.fakeax(ai) handles.fakerax(ai)];
try
    set(axez,'xlim',single(newxlim));
end

xlab=get(handles.allgraphs(ai),'xlabel');
pos=get(xlab,'position');
pos(1)=(newxlim(2)+newxlim(1))/2;
set(xlab,'position',pos);

if ismember('alwaysrotatexticks',udata.attributes);
    ar=true;
else
    ar=false;
end
ravemovecustomticks(handles.activegraph,[],ar);



function zoomybar(src,ev,xbar)
handles=guidata(src);
ax=gca;
ai=get(ax,'userdata');
udata=get(handles.fakeax(ai),'userdata');


clicked=get(ax,'currentpoint');
val=clicked(1,2);

lastclicked=get(0,'userdata');
lastval=lastclicked(1,2);
set(0,'userdata',clicked);
deltaval=(val-lastval)./2;
ydata=get(gco,'ydata');
ydata=ydata+deltaval;

%move marker within bounds
pos=get(ax,'position');
lims=[3 pos(4)-13];

if ydata(2)+deltaval>lims(2)
    deltaval=lims(2)-ydata(2);
elseif ydata(1)+deltaval<lims(1)
    deltaval=lims(1)-ydata(1);
end

yd=ydata+deltaval;

set(gco,'ydata',yd)

ylow=findobj(ax,'tag','ylow');
yhigh=findobj(ax,'tag','yhigh');

set(ylow,'ydata',yd(1));
set(yhigh,'ydata',yd(2));

%do zooming:
ylim=udata.format.ylim;
yr=ylim(2)-ylim(1);

rellow=(yd(1)-3)./(pos(4)-16);
relhigh=(yd(2)-3)./(pos(4)-16);

newylim=ylim(1)+yr.*[rellow relhigh];
axez=[handles.allgraphs(ai) handles.fakeax(ai) handles.fakerax(ai)];
try
    set(axez,'ylim',single(newylim));
end

if ismember('alwaysrotatexticks',udata.attributes);
    ar=true;
else
    ar=false;
end
ravemovecustomticks(handles.activegraph,[],ar);
