function cmap=getvariablecolors(numrows,name)
%input1: number of colors to get
%input2: name of colormap to use.
%if more colors are needed than are in the map, hsv is used to pick up the slack.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% Written by: Matthew Daskilewicz mdaskilewicz@asdl.gatech.edu



switch name
    case 'accel'
        cmap=[0 0 128;
            255 0 255;
            255 255 0;
            0 255 255;
            128 0 128;
            128 0 0;
            0 128 128;
            0 0 255;
            0 204 255;
            204 255 255;
            204 255 204;
            255 255 153;
            153 204 255;
            255 153 204;
            204 153 255;
            255 204 153;
            51 102 255;
            51 204 204;
            153 204 0;
            255 204 0;
            255 153 0;
            255 102 0;
            102 102 153;
            150 150 150;
            0 51 102;
            51 153 102;
            0 51 0;
            51 51 0;
            153 51 0;
            153 51 102;
            51 51 153;
            51 51 51;
            0 0 0;
            255 255 255;
            255 0 0;
            0 255 0;
            0 0 255;
            255 255 0;
            255 0 255;
            0 255 255;
            128 0 0;
            0 128 0;
            0 0 128;
            128 128 0;
            128 0 128;
            0 128 128;
            192 192 192;
            128 128 128;
            153 153 255;
            153 51 102;
            255 255 204;
            204 255 255;
            102 0 102;
            255 128 128;
            0 102 204;
            204 204 255]/255;

    case 'altaccel' %excel colors starting at midpoint.

        cmap=[255 0 0;
            0 255 0;
            0 0 255;
            255 255 0;
            255 0 255;
            0 255 255;
            128 0 0;
            0 128 0;
            0 0 128;
            128 128 0;
            128 0 128;
            0 128 128;
            192 192 192;
            128 128 128;
            153 153 255;
            153 51 102;
            255 255 204;
            204 255 255;
            102 0 102;
            255 128 128;
            0 102 204;
            204 204 255
            0 0 128;
            255 0 255;
            255 255 0;
            0 255 255;
            128 0 128;
            128 0 0;
            0 128 128;
            0 0 255;
            0 204 255;
            204 255 255;
            204 255 204;
            255 255 153;
            153 204 255;
            255 153 204;
            204 153 255;
            255 204 153;
            51 102 255;
            51 204 204;
            153 204 0;
            255 204 0;
            255 153 0;
            255 102 0;
            102 102 153;
            150 150 150;
            0 51 102;
            51 153 102;
            0 51 0;
            51 51 0;
            153 51 0;
            153 51 102;
            51 51 153;
            51 51 51;
            0 0 0;
            255 255 255;]/255;

    case 'hsv'
        cmap=hsv(numrows);
    case 'rave' %aka althsv
        cmap=hsv(round(numrows*1.15));
        cmap=cmap(1:numrows,:);
        
    case 'jet'
        cmap=jet(numrows);
end

%pad with hsv:
if size(cmap,1)>numrows
    cmap=cmap(1:numrows,:);
elseif size(cmap,1)<numrows
    cmap=[cmap;hsv(numrows-size(cmap,1))];
end



