function formattabbackgroundframe(src,eventdata)
%rave format tab.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% do work

appeartext=text(.15-.10317,.97*1.0317-.0317,'Appearance','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

fontlist=listfonts;
sizelist={'10';'12';'14';'16';'18';'20';'22';'24';'28';'32';'36';'42';'48';'60';'72';'96'};

fontvalue=find(strcmpi(fontlist,udata.format.fontname),1);
if isempty(fontvalue)
    fontvalue=1;
end

sizevalue=find(strcmp(sizelist,num2str(udata.format.fontsize)),1);
if isempty(sizevalue)
    sizevalue=1;
end

if udata.format.fontstyle==3
    boldvalue=1;
    italicvalue=1;
elseif udata.format.fontstyle==1
    boldvalue=1;
    italicvalue=0;
elseif udata.format.fontstyle==2;
    italicvalue=1;
    boldvalue=0;
else
    boldvalue=0;
    italicvalue=0;
end

titletext=uicontrol('position',[origin(1)+25 origin(2)+332+200+40 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+333+200+40 180 20],...
    'style','edit','string',udata.format.titlestring,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

fontpicker=uicontrol('position',[origin(1)+25 origin(2)+124+450-40 219 22],'style','popupmenu',...
    'string',fontlist,'parent',handles.fig,'max',10,'value',fontvalue,...
    'backgroundcolor',[1 1 1],'tag','fontpicker','callback',@fontpicker_callback);

boldbutton=uicontrol('position',[origin(1)+25 origin(2)+90+455-40 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('bold.bmp'),...
    'tag','boldbutton','callback',@fontpicker_callback,'value',boldvalue);

italicbutton=uicontrol('position',[origin(1)+55 origin(2)+90+455-40 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('italic.bmp'),...
    'tag','italicbutton','callback',@fontpicker_callback,'value',italicvalue);

fontdownbutton=uicontrol('position',[origin(1)+145 origin(2)+90+455-40 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontdown.bmp'),...
    'callback',@fontdown_callback);

fontsizer=uicontrol('position',[origin(1)+176 origin(2)+90+455-40 40 22],'style','popupmenu',...
    'string',sizelist,...
    'parent',handles.fig,'max',1,'value',sizevalue,...
    'backgroundcolor',[1 1 1],'tag','fontsizer','callback',@fontpicker_callback);

fontupbutton=uicontrol('position',[origin(1)+220 origin(2)+90+455-40 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontup.bmp'),...
    'callback',@fontup_callback);

bgtext=uicontrol('position',[origin(1)+57 origin(2)+569-25-100 180 20],...
    'style','text','string','Background Color','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
bgblob=uicontrol('position',[origin(1)+30 origin(2)+573-25-100 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.bgcolor,...
    'callback',@bgcolor_callback);

edgetext=uicontrol('position',[origin(1)+57 origin(2)+569-50-100 180 20],...
    'style','text','string','Edge Color','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
edgeblob=uicontrol('position',[origin(1)+30 origin(2)+573-50-100 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.edgecolor,...
    'callback',@edgecolor_callback);

colortext=uicontrol('position',[origin(1)+57 origin(2)+569-75-100 180 20],...
    'style','text','string','Title Color','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
colorblob=uicontrol('position',[origin(1)+30 origin(2)+573-75-100 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.fontcolor,...
    'callback',@fontcolor_callback);


%width slider:
widthtext=uicontrol('position',[origin(1)+30 origin(2)+569-75-100-40 180 20],...
    'style','text','string','Edge Width','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

[jslider hslider]=javacomponent('javax.swing.JSlider',[origin(1)+60 origin(2)+327 128 27]);
jslider.setPaintTicks(1)
jslider.setSnapToTicks(1)
jslider.setMinimum(0)
jslider.setMaximum(10)
jslider.setMajorTickSpacing(1);
jslider.setValue(udata.format.edgewidth);
set(jslider,'background',java.awt.Color.white)
set(jslider,'StateChangedCallback',{@linewidth_callback,handles.fig});

%handles.javacomps=jslider;

widthaxes=axes('units','pixels','position',[origin(1)+125-50 origin(2)+167-35+185 110 5],'visible','off');
gauge=imread('widthgauge.bmp');
image(gauge,'parent',widthaxes)
set(widthaxes,'visible','off');

%radius slider:
radiustext=uicontrol('position',[origin(1)+30 origin(2)+569-75-100-40-100 180 20],...
    'style','text','string','Corner Radius','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

[jslider2 hslider2]=javacomponent('javax.swing.JSlider',[origin(1)+130-25-50 origin(2)+167-25+185-100 125 27]);
jslider2.setPaintTicks(1)
jslider2.setSnapToTicks(1)
jslider2.setMinimum(0)
jslider2.setMaximum(5)
jslider2.setMajorTickSpacing(1);
jslider2.setValue(udata.format.radius./10);
set(jslider2,'background',java.awt.Color.white)
set(jslider2,'StateChangedCallback',{@radius_callback,handles.fig});

radiustext2=uicontrol('position',[origin(1)+30+10 origin(2)+569-75-100-40-150 180 20],...
    'style','text','string','square                   round','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal');

% handles.javacomps=[jslider jslider2];

%% group items and finish up
handles.tabobjects=[titletext titlebox appeartext fontpicker boldbutton italicbutton fontdownbutton...
    fontsizer fontupbutton bgtext bgblob edgetext edgeblob colortext colorblob hslider widthaxes widthtext...
    radiustext hslider2 radiustext2];

handles.activetab='format';
set(handles.infobar,'string','');
guidata(src,handles);

function fontdown_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');

value=get(fontsizer,'value');
if value>=2
    value=value-1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end

function fontup_callback(src,ev)
handles=guidata(src);
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
maxvalue=numel(get(fontsizer,'string'));

value=get(fontsizer,'value');
if value<maxvalue
    value=value+1;
    set(fontsizer,'value',value);
    fontpicker_callback(src,ev);
end

function fontpicker_callback(src,ev) %#ok<INUSD>

handles=guidata(src);
getudata;

fontpicker=findobj(handles.tabobjects,'tag','fontpicker');
fontsizer=findobj(handles.tabobjects,'tag','fontsizer');
boldbutton=findobj(handles.tabobjects,'tag','boldbutton');
italicbutton=findobj(handles.tabobjects,'tag','italicbutton');
%underlinebutton=findobj(handles.tabobjects,'tag','underlinebutton');

fontlist=get(fontpicker,'string');
fontname=fontlist(get(fontpicker,'value'));

sizelist=get(fontsizer,'string');
fontsize=str2double(sizelist{get(fontsizer,'value')});

if get(boldbutton,'value') && get(italicbutton,'value')
    fontstyle=3;
elseif get(boldbutton,'value')
    fontstyle=1;
elseif get(italicbutton,'value')
    fontstyle=2;
else
    fontstyle=4;
end

udata.format.fontname=fontname{1};
udata.format.fontsize=fontsize;
udata.format.fontstyle=fontstyle;

setudata;
guidata(src,handles);

ravecreatebackgroundframe(handles.fig,[]);


function fontcolor_callback(src,ev)
handles=guidata(src);
uicontrol(handles.dummyobj)

udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.fontcolor,'Choose a background color');

%update fakerax userdata
udata.format.fontcolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(udata.view.title,'color',newcolor);

function bgcolor_callback(src,ev)
handles=guidata(src);
uicontrol(handles.dummyobj)

udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.bgcolor,'Choose a background color');

%update fakerax userdata
udata.format.bgcolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(udata.view.rectangle,'facecolor',newcolor);

if udata.format.titleposition~=1 %not on top
    set(udata.view.title,'backgroundcolor',newcolor);
end

set(src,'backgroundcolor',newcolor);



function edgecolor_callback(src,ev)
handles=guidata(src);
uicontrol(handles.dummyobj)

udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.edgecolor,'Choose a background color');

set(src,'backgroundcolor',newcolor);

%update fakerax userdata
udata.format.edgecolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

set(udata.view.rectangle,'edgecolor',newcolor);



function title_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.format.titlestring=get(src,'string');
set(udata.view.title,'string',get(src,'string'));

set(handles.fakeax(handles.activeindex),'userdata',udata);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function linewidth_callback(src,eventdata,fighandle) %#ok<INUSL>

handles=guidata(fighandle);

%update inputs

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.edgewidth=src.getValue/2;
set(handles.fakeax(handles.activeindex),'userdata',udata);

if src.getValue==0
    set(udata.view.rectangle,'linestyle','none');
else
    set(udata.view.rectangle,'linewidth',src.getValue/2,'linestyle','-');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function radius_callback(src,eventdata,fighandle) %#ok<INUSL>

handles=guidata(fighandle);

%update inputs

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.radius=src.getValue*10;
set(handles.fakeax(handles.activeindex),'userdata',udata);

raveresizeaxesbackgroundframe(handles.fig,[],handles.activeindex)

