function ravecreatescrollabletext(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;
xcol=udata.view.x;

%make data:

%process expression:
indata=udata.view.expression;




%look for file references:
matches=parenthesesmatch(indata,'{','}');
linenumbers=parenthesesmatch(indata,'[',']');

txts={};

for f=1:size(matches,1)
    fid=fopen(indata(matches(f,1)+1:matches(f,2)-1));
    if fid>0
        
        %look for line numbers:
        idx=linenumbers(:,1)==matches(f,2)+1;
        idx=linenumbers(idx,:);
        if ~isempty(idx)
            theselines=indata(idx(1)+1:idx(2)-1);
            theselines=strrep(theselines,'-',':');
            theselines=eval(theselines);
            start=theselines(1);
            finish=theselines(end);
        else
            start=1;
            finish=inf;
        end
        
        tline=fgetl(fid);
        txts{f}={};
        count=1;
        while ischar(tline) && count<=finish;
            txts{f}{end+1}=tline;
            tline=fgetl(fid);
            count=count+1;
        end
        
        txts{f}=txts{f}(start:end);
        
        
    else
        txts{f}={'(File Not Found)'};
    end
end

%allocate strings for txts:
strs=cell(numel(txts),1);

for f=1:numel(strs)
    
    bits=cellfun(@length,txts{f});
    bitz=[0 cumsum(bits+1)];
    strs{f}=char(zeros(1,sum(bits)+numel(txts{f})));
    for s=1:numel(txts{f});
        strs{f}(bitz(s)+1:bitz(s+1))=[txts{f}{s},char(10)];
    end
end

%insert file text into indata:
if numel(strs)==0
    fulldata=indata;
else
    fulldata=indata(1:matches(1)-1);
    for s=1:numel(strs)
        %determine whether to stop after the filename or after the line
        %numbers:
        %look for line numbers:
        idx=linenumbers(:,1)==matches(s,2)+1;
        if isempty(idx)
            startat=matches(s,2)+1;
        else
            startat=linenumbers(s,2)+1;
        end
        
        if s<numel(strs)
            stopat=matches(s+1,1)-1;
        else
            stopat=length(indata);
        end
        fulldata=[fulldata,strs{s}(1:end-1),indata(startat:stopat)];
    end
    
end

if udata.format.fontstyle==3
    style={'fontweight','bold','fontangle','italic'};
    javastyle='bold';
elseif udata.format.fontstyle==1
    style={'fontweight','bold','fontangle','normal'};
    javastyle='bold';
elseif udata.format.fontstyle==2
    style={'fontweight','normal','fontangle','italic'};
    javastyle='italic';
else
    style={'fontweight','normal','fontangle','normal'};
    javastyle='plain';
end


%replace tabs with spaces since tabs arent directly supported
%TO DO: smartly insert a variable number of spaces to make tabs works like tabs.
fulldata=strrep(fulldata,char(9),'    ');

%determine how big to make the table:
nrows=nnz(fulldata==char(10));

%Font size interpolation info
%charwidths=handles.prefs.fonts.graphwidths;

[w,fontheight]=ravecalculatestringlength(fulldata,udata.format.fontname,udata.format.fontsize,javastyle,handles.axiscanvas);
height=fontheight*nrows;


%determine row widths:
breaks=[1 find(fulldata==char(10)) length(fulldata)];
maxline=0;

for i=1:numel(breaks)-1
    %thislength=sum(charwidths(fulldata(breaks(i):breaks(i+1))));
    thislength=ravecalculatestringlength(fulldata(breaks(i):breaks(i+1)),udata.format.fontname,udata.format.fontsize,javastyle,handles.axiscanvas);
    if thislength>maxline
        maxline=thislength;
    end
end
 

width=maxline+10;

if height<48;height=48;end
if width<98;width=98;end

%                                                   data,rownames,rowheight,colnames,colwidths,headerwidth,headerheight,rowcolors,rhcolors);
ravemaketablecore(handles.fig,[],handles.activeindex,{fulldata},{},height,{},width,0.1,0.1,[1 1 1],[1 1 1]);

udata=get(handles.fakeax(handles.activeindex),'userdata');

%realign text to top left corner:
t=udata.view.texthandles;
set(t,'hor','left','ver','top')
set(t,'position',[4 0 0]);

%apply font style:
set(t,style{:});


set(handles.fakeax(handles.activeindex),'hittest','on','buttondownfcn',@selecttableallpoints)

raveresizetable(handles.fig,[],handles.activeindex);
%fix scrolling
verttablescroll(handles.activegraph,[],0)



