function derivativeprofilerchangevaltexts(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

strng=get(src,'string');
lastbracket=find(strng{end}=='}',1,'last');
lastcolor=get(get(src,'parent'),'xcolor');
set(get(src,'parent'),'xcolor',[0 0 0]);
set(src,'string',strng{end}(lastbracket+1:end));
set(src,'editing','on');

oldfun=get(handles.fig,'windowbuttondownfcn');
set(0,'userdata',src);

set(handles.fig,'windowbuttondownfcn',{@changevaltextsdone,oldfun,lastcolor,get(src,'parent')});

function changevaltextsdone(src,ev,oldfun,lastcolor,parent)

handles=guidata(src);
% try
ai=get(get(0,'userdata'),'userdata');
% catch %#ok<CTCH>
%     return
% end
udata=get(handles.fakeax(ai),'userdata');

set(handles.fig,'windowbuttondownfcn',oldfun) %do this first in case of errors later.

d=udata.view.dataset;
a=udata.view.analysis;

txt=get(0,'userdata');

ranges=[handles.minlimit{d}{a}' handles.maxlimit{d}{a}'];
newval=str2double(get(txt,'string'));

%restore axes color
set(parent,'xcolor',lastcolor);

if isnan(newval);return;end

[junk thisvar]=find(handles.subfakeax{ai}==parent);
thisvar=udata.view.x(thisvar);
handles.xdials{d}{a}(thisvar)=newval;
guidata(handles.fig,handles);

%make new string:
set(get(parent,'xlabel'),'string',{' ';' ';['\color[rgb]{',num2str(udata.format.linecolor),'} ',num2str(newval,5)]});

raveupdateanalysis(handles.fig,[],'xdials',[]);




