function raveupdatepprof(src,eventdata,fig) %#ok<INUSL>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(fig);
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;

xcol=udata.view.x;
ycol=udata.view.y;


%% UPDATE GRAPH:
%get variable values from slide bars:

xdials=handles.xdials{d}{a};


vars=union(handles.funvars{d}{xcol},handles.funvars{d}{ycol});
% 
% varz=handles.alldata{udata.view.dataset}(1,:);
% varz(vars)=values;
nvars=numel(vars);

outputs=raveevaluatefunction(handles.fig,d,[udata.view.x udata.view.y],xdials);

xvalue=outputs(:,1);
yvalue=outputs(:,2);

set(udata.explore.pprof.pspot,'xdata',xvalue,'ydata',yvalue);

% 
% set(handles.pprof.xvaltext,'string',sprintf('%-12.8g',xvalue));
% set(handles.pprof.yvaltext,'string',sprintf('%-12.8g',yvalue));

npoints=13;
%update paths:
for g=1:nvars
    thisvar=vars(g);
    %thiscolor=cmap(g,:);
    
    startpoint=xdials;
    
    range=udata.explore.pprof.ranges(thisvar,:);
    
    steps=interp1([1 npoints],range,1:npoints);
    
    xdata=repmat(startpoint,[npoints 1]);
    xdata(:,thisvar)=steps;
    
    outputs=raveevaluatefunction(handles.fig,d,[udata.view.x udata.view.y],xdata);
    
    xvalues=outputs(:,1);
    yvalues=outputs(:,2);
    
    set(udata.explore.pprof.linepaths(g),'xdata',xvalues,'ydata',yvalues);
    set(udata.explore.pprof.lineplus(g),'xdata',xvalues(end),'ydata',yvalues(end)); 
    
end

%UPDATE TICK MARKS:
tickcheck=findobj(handles.tabobjects,'tag','tickcheck');
if get(tickcheck,'value') %ticks are on..... do work:
    %% MAKE TICK MARKS:
    npoints=5; %path resolution
    for p=1:nvars
        thisvar=vars(p);
        %thiscolor=cmap(p,:);
        startpoint=varz;
        range=udata.explore.pprof.ranges(thisvar,:);
        steps=interp1([1 npoints],range,1:npoints);
        
        xdata=repmat(startpoint,[npoints 1]);
        xdata(:,thisvar)=steps;

        outputs=raveevaluatefunction(handles.fig,d,[udata.view.x udata.view.y],xdata);
        xvalues=outputs(:,1);
        yvalues=outputs(:,2);

        %make paths:
        set(udata.explore.pprof.tickpaths(p),'xdata',xvalues,'ydata',yvalues);

    end
end

%fix axes limits:
set([handles.fakeax(handles.activeindex) handles.fakerax(handles.activeindex)],...
    'xlim',get(handles.activegraph,'xlim'),'ylim',get(handles.activegraph,'ylim'))

guidata(handles.fig,handles);
