function viewtabcarpet2d(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.

d=udata.view.dataset;
a=udata.view.analysis;


%% text headers

projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


%% text labels

analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');

datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

%% variable lists
xvars=handles.funvars{udata.view.dataset}{udata.view.z(1)};
for yy=1:length(udata.view.z)
    xvars=union(xvars,handles.funvars{udata.view.dataset}{udata.view.z(yy)});
end

xvars=find(~strcmp(handles.datatype{d},'constant') );%^ & ~handles.isfunction{d});
allnames=handles.allnames{d};

xaxistext=text(.25-.10317,.72*1.0317-.0317,'X-Axis Variable (dep):','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,.65*1.0317-.0317,'Y-Axis Variable (dep):','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'color',[0 0 0],'fontweight','bold');
zaxistext=text(.25-.10317,.58*1.0317-.0317,'1st Sweep Variable (indep):','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'color',[0 0 0],'fontweight','bold');
caxistext=text(.25-.10317,.355,'2nd Sweep Variable (indep):','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'color',[0 0 0],'fontweight','bold');


xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+405 180 30],...
    'style','popupmenu','string',allnames,'value',udata.view.x,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','max',1,'callback',@xaxismenu_callback);

yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+360 180 30],...
    'style','popupmenu','string',allnames,'value',udata.view.y,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','max',1,'callback',@yaxismenu_callback);

zaxismenu=uicontrol('position',[origin(1)+55 origin(2)+315 180 30],...
    'style','popupmenu','string',handles.allnames{d},...
    'backgroundcolor',[1 1 1],'tag','zaxismenu','callback',@zaxismenu_callback,'value',udata.view.z);

zaxischeck=uicontrol('position',[origin(1)+55 origin(2)+315-22 180 30],...
    'style','checkbox','string','Draw path(s) of this sweep',...
    'backgroundcolor',[1 1 1],'tag','zcheck','callback',@visiblecheck_callback,'value',udata.view.isvisible1);

levelstext1=uicontrol('position',[origin(1)+35 origin(2)+268 220 22],...
    'style','text','string','Number of values to sweep through:',...
    'backgroundcolor',[1 1 1],'tag','','hor','left',...
    'callback',@zaxismenu_callback,'value',udata.view.isvisible1,'fontweight','normal','fontsize',10);

%width slider:
[jslider hslider1]=javacomponent('javax.swing.JSlider',[origin(1)+55 origin(2)+242 160 27]);
jslider.setPaintTicks(1)
jslider.setSnapToTicks(1)
jslider.setMinimum(1)
jslider.setMaximum(20)
jslider.setMajorTickSpacing(1);
jslider.setValue(udata.view.numpts1);
set(jslider,'background',java.awt.Color.white)
set(jslider,'StateChangedCallback',{@numpts1_callback,handles.fig});

% handles.javacomps=jslider;

h1text=uicontrol('position',[origin(1)+220 origin(2)+240 30 30],'style','text',...
    'string',num2str(udata.view.numpts1),'backgroundcolor',[1 1 1],'fontsize',11,'fontweight','bold','tag','h1text');

if udata.view.c>0
    cvalue=find(ismember(find(~handles.isfunction{d}),udata.view.c))+1;
else
    cvalue=1;
end

caxismenu=uicontrol('position',[origin(1)+55 origin(2)+182 180 30],...
    'style','popupmenu','string',[cellstr(' ') handles.allnames{d}],...
    'callback',@caxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','caxismenu','max',100,'value',cvalue);

caxischeck=uicontrol('position',[origin(1)+55 origin(2)+182-22 180 30],...
    'style','checkbox','string','Draw path(s) of this sweep',...
    'backgroundcolor',[1 1 1],'tag','caxischeck','callback',@visiblecheck_callback,'value',udata.view.isvisible2);

levelstext2=uicontrol('position',[origin(1)+35 origin(2)+182-22-25 220 22],...
    'style','text','string','Number of values to sweep through:',...
    'backgroundcolor',[1 1 1],'tag','','hor','left',...
    'callback',@zaxismenu_callback,'value',udata.view.isvisible1,'fontweight','normal','fontsize',10);

%width slider:
[jslider hslider2]=javacomponent('javax.swing.JSlider',[origin(1)+55 origin(2)+182-47-26 160 27]);
jslider.setPaintTicks(1)
jslider.setSnapToTicks(1)
jslider.setMinimum(1)
jslider.setMaximum(20)
jslider.setMajorTickSpacing(1);
jslider.setValue(udata.view.numpts1);
set(jslider,'background',java.awt.Color.white)
set(jslider,'StateChangedCallback',{@numpts2_callback,handles.fig});

% handles.javacomps=jslider;

h2text=uicontrol('position',[origin(1)+220 origin(2)+182-47-26-2 30 30],'style','text','tag','h2text',...
    'string',num2str(udata.view.numpts1),'backgroundcolor',[1 1 1],'fontsize',11,'fontweight','bold');


%draw this on top:
optionstext=text(.15-.10317,.15*1.0317-.0317,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title,'visible','off');


%% variable lists

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','callback',@analysismenu_callback,'value',a);

datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','callback',@datasetmenu_callback,'value',d);

showcurrentpointcheck=uicontrol('position',[origin(1)+55 origin(2)+45 200 26],...
    'style','checkbox','string','Show Current Point',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.view.showcurrentpoint,'callback',@showcurrentpoint_callback);



%% buttons
scalebutton=uicontrol('position',[origin(1)+55 origin(2)+10 180 30],...
    'style','pushbutton','string','Scale/Transform Variables','backgroundcolor',handles.colors.buttonbg,'visible','off');

%% group items and finish up
handles.tabobjects=[datasettext datasetmenu xaxistext xaxismenu zaxistext zaxismenu yaxistext yaxismenu,...
    scalebutton analysistext projecttext analysismenu dataseriestext optionstext showcurrentpointcheck,...
    caxistext caxismenu zaxischeck hslider1 h1text levelstext1 hslider2 h2text levelstext2 caxischeck];

handles.activetab='view';

guidata(src,handles);

%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata)

handles=guidata(src);
%update other menus to show correct variables

datasetmenu=findobj(handles.tabobjects,'tag','datasetmenu');

d=get(datasetmenu,'value');

%get initial columns for this data set: (need at least 2 x's for a
%scatterplot matrix)
if ~all(handles.isresponse{d}==0)
    x=find((~handles.isconstant{d} & ~handles.isresponse{d}),2);
else
    x=find((~handles.isconstant{d}),2);
end

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.dataset=get(datasetmenu,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);

viewtabcarpet2d(src,[]);

ravecreatecarpet2d(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata)
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatecarpet2d(src,[]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.x=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatecarpet2d(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.y=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatecarpet2d(src,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function zaxismenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

zvars=find(~handles.isfunction{udata.view.dataset});
udata.view.z=get(src,'value');


set(handles.fakeax(handles.activeindex),'userdata',udata);


ravecreatecarpet2d(src,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function caxismenu_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%zvars=find(~handles.isfunction{udata.view.dataset});
udata.view.c=get(src,'value')-1;


%[steps,junk]=ravecalculatexsteps(handles.fig,udata.view.dataset,udata.view.analysis,udata.view.c,5);
%udata.view.steps=steps{1};
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatecarpet2d(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function numpts1_callback(jsrc,jev,src) %#ok<INUSL>
handles=guidata(src);
getudata;
udata.view.numpts1=jsrc.getValue;
setudata;

h1text=findobj(handles.tabobjects,'tag','h1text');
set(h1text,'string',num2str(jsrc.getValue));
ravecreatecarpet2d(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function numpts2_callback(jsrc,jev,src) %#ok<INUSL>
handles=guidata(src);
getudata;
udata.view.numpts2=jsrc.getValue;
setudata;
h2text=findobj(handles.tabobjects,'tag','h2text');
set(h2text,'string',num2str(jsrc.getValue));
ravecreatecarpet2d(handles.fig,[]);

function visiblecheck_callback(src,ev)
handles=guidata(src);
getudata;

if get(src,'value')
    newstr='on';
    
else
    newstr='off';
end


if strcmp(get(src,'tag'),'zcheck')
    target=findobj(handles.activegraph,'tag','main2');
    udata.view.isvisible1=get(src,'value');
else
    target=findobj(handles.activegraph,'tag','main1');
    udata.view.isvisible2=get(src,'value');
end

set(target,'vis',newstr);

setudata;


function showcurrentpoint_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.showcurrentpoint=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

if get(src,'value')
    set(udata.view.currentpointhandle,'visible','on')
else
    set(udata.view.currentpointhandle,'visible','off')
end



