function viewtabplaneprofiler(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.

d=udata.view.dataset;
a=udata.view.analysis;


%% text headers

projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

dataseriestext=text(.15-.10317,.75*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);


%% text labels

analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');

datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

%% variable lists

xyvars=find(handles.isfunction{d});
allnames=handles.allnames{d};
xyvarnames=allnames(xyvars); %#ok<FNDSB>


xaxistext=text(.25-.10317,.72*1.0317-.0317,'X-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,.65*1.0317-.0317,'Y-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');

xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+405 180 30],...
    'style','popupmenu','string',xyvarnames,'value',find(ismember(xyvarnames,allnames(udata.view.x))),...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','max',1,'callback',@xaxismenu_callback);

yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+360 180 30],...
    'style','popupmenu','string',xyvarnames,'value',find(ismember(xyvarnames,allnames(udata.view.y))),...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','max',1,'callback',@yaxismenu_callback);

layouthandles=[xaxistext xaxismenu yaxistext yaxismenu];

if udata.view.npoints>20
    value=(udata.view.npoints-20)/2+20;
else
    value=udata.view.npoints;
end

nconttext=uicontrol('position',[origin(1)+37 origin(2)+280-85+90 200 20],...
    'style','text','string','Number of points per path:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
ncont=uicontrol('position',[107+3.6*value origin(2)+235-85+90 50 20],...
    'style','text','string',num2str(udata.view.npoints),'backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',12,'horizontalalignment','left','fontweight','bold');


[jslider1 hslider1]=javacomponent('javax.swing.JSlider',[origin(1)+40 origin(2)+255-85+90 190 30]);
jslider1.setPaintTicks(1)

jslider1.setSnapToTicks(0)
jslider1.setMinimum(2)
jslider1.setMaximum(50)
jslider1.setMajorTickSpacing(2);
jslider1.setValue(value);
set(jslider1,'background',java.awt.Color.white)
set(jslider1,'StateChangedCallback',{@ncont_Callback,ncont});

% handles.javacomps=jslider1;

%draw this on top:
optionstext=text(.15-.10317,.15*1.0317-.0317,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title,'visible','off');


%% variable lists

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','callback',@analysismenu_callback,'value',a);

datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','callback',@datasetmenu_callback,'value',d);


%% buttons

scalebutton=uicontrol('position',[origin(1)+55 origin(2)+10 180 30],...
    'style','pushbutton','string','Scale/Transform Variables','backgroundcolor',handles.colors.buttonbg,'visible','off');

showpointscheck=uicontrol('position',[origin(1)+55 origin(2)+45 200 26],...
    'style','checkbox','string','Show Data Set',...
    'backgroundcolor',handles.colors.tabbg,'value',udata.format.showpoints,'callback',@showpoints_callback,'visible','off');

%% group items and finish up
handles.tabobjects=[datasettext datasetmenu layouthandles,...
    scalebutton analysistext projecttext analysismenu dataseriestext optionstext showpointscheck,...
    hslider1 ncont nconttext];

handles.activetab='view';

guidata(src,handles);

%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata)

handles=guidata(src);
%update other menus to show correct variables

datasetmenu=findobj(handles.tabobjects,'tag','datasetmenu');

d=get(datasetmenu,'value');

%get initial columns for this data set: (need at least 2 x's for a
%scatterplot matrix)
if ~all(handles.isresponse{d}==0)
    x=find((~handles.isconstant{d} & ~handles.isresponse{d}),2);
else
    x=find((~handles.isconstant{d}),2);
end

%set fakeax userdata
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.dataset=get(datasetmenu,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);

ravecreateplaneprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata)
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateplaneprofiler(src,[]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

xvars=find(handles.isfunction{udata.view.dataset});
udata.view.x=xvars(get(src,'value'));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateplaneprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

xvars=find(handles.isfunction{udata.view.dataset});
udata.view.y=xvars(get(src,'value'));
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreateplaneprofiler(src,[]);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function ncont_Callback(src,ev,hObject) %#ok<INUSL>
%hObject = nbars
npoints=src.getValue;
if npoints>20;npoints=20+(npoints-20)*2;end
pos=get(hObject,'position');
set(hObject,'string',sprintf('%3.0f',npoints),'position',[49+58+3.6*src.getValue pos(2:4)]);

if src.getValueIsAdjusting;return;end

handles=guidata(hObject);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.npoints=npoints;
set(handles.fakeax(handles.activeindex),'userdata',udata)
guidata(hObject,handles);
%update histogram:
ravecreateplaneprofiler(handles.fig,[]);

