function viewtabsurfaceprofiler(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,2,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
view=udata.view; %get view tab structure.
d=view.dataset;
a=view.analysis;

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
dataseriestext=text(.15-.10317,.77*1.0317-.0317,'Data Series','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
optionstext=text(.15-.10317,.16*1.0317-.0317,'Options','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title,'visible','off');

%% text labels
analysistext=text(.25-.10317,.920*1.0317-.0317,'Choose Parent Analysis:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold','backgroundcolor','none');
datasettext=text(.25-.10317,.85*1.0317-.0317,'Choose a Data Set:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
xaxistext=text(.25-.10317,.74*1.0317-.0317,'X-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
yaxistext=text(.25-.10317,.67*1.0317-.0317,'Y-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
zaxistext=text(.25-.10317,.60*1.0317-.0317,'Z-Axis Variable:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');
colortext=text(.25-.10317,.53*1.0317-.0317,'Color Surface by:','horizontalalignment','left',...
    'backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',10,'fontname','arial','color',[0 0 0],'fontweight','bold');


%% variable lists


%make list of resposne names:
allnames=handles.allnames{d};
respnames=allnames(logical(handles.isfunction{d}));
inputnames=allnames(~logical(handles.isfunction{d}) & ~logical(handles.isconstant{d}));

%convert z column into resposne column number:

xvalue=find(ismember(inputnames,allnames(udata.view.x)));
yvalue=find(ismember(inputnames,allnames(udata.view.y)));
zvalue=find(ismember(respnames,allnames(udata.view.z)));
cvalue=find(ismember(respnames,allnames(udata.view.c)));

analysismenu=uicontrol('position',[origin(1)+55 origin(2)+535 180 30],...
    'style','popupmenu','string',handles.analysisnames,'callback',@analysismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','analysismenu','value',view.analysis);
datasetmenu=uicontrol('position',[origin(1)+55 origin(2)+490 180 30],...
    'style','popupmenu','string',handles.datasetnames,'callback',@datasetmenu_callback,...
    'backgroundcolor',[1 1 1],'tag','datasetmenu','value',view.dataset);
xaxismenu=uicontrol('position',[origin(1)+55 origin(2)+421 180 30],...
    'style','popupmenu','string',inputnames,'callback',@xaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','xaxismenu','value',xvalue);
yaxismenu=uicontrol('position',[origin(1)+55 origin(2)+376 180 30],...
    'style','popupmenu','string',inputnames,'callback',@yaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','yaxismenu','value',yvalue);
zaxismenu=uicontrol('position',[origin(1)+55 origin(2)+331 180 30],...
    'style','popupmenu','string',respnames,'callback',@zaxismenu_callback,...
    'backgroundcolor',[1 1 1],'tag','zaxismenu','value',zvalue);
colormenu=uicontrol('position',[origin(1)+55 origin(2)+286 180 30],...
    'style','popupmenu','string',[respnames(1:end),cellstr('<Solid Color>')],'callback',@colormenu_callback,...
    'backgroundcolor',[1 1 1],'tag','colormenu','value',length(handles.allnames{1}),'value',cvalue);

currentpointcheck=uicontrol('position',[origin(1)+55 origin(2)+256 180 30],...
    'style','checkbox','string','Show current point on surface','callback',@showcurrentpoint_callback,...
    'backgroundcolor',[1 1 1],'value',udata.view.showcurrentpoint);


%% buttons
changeunitsbutton=uicontrol('position',[origin(1)+55 origin(2)+38 180 30],...
    'style','pushbutton','string','Change Units','backgroundcolor',handles.colors.buttonbg,'enable','off','visible','off');


% try
%     idata=imread(fullfile(matlabroot,'/toolbox/matlab/icons/tool_rotate_3d.png'),'backgroundcolor',handles.colors.togglebuttonbg);
%     idata=double(idata)./(255^2);
%     %alpha=double(alpha)./(255^2);
%
%     idata(idata>1)=1;
%     %alpha(alpha>1)=1;
%
%     cdata=ones(26,200,3);
%     cdata(:,:,1)=cdata(:,:,1).*handles.colors.togglebuttonbg(1);
%     cdata(:,:,2)=cdata(:,:,2).*handles.colors.togglebuttonbg(2);
%     cdata(:,:,3)=cdata(:,:,3).*handles.colors.togglebuttonbg(3);
%     cdata(5:20,7:22,:)=idata;
%     cdata=uint8(cdata.*255);
% catch
%     cdata=[];
% end

%make pixel coordinates:
% rotatebutton=drawtogglebutton(handles.fig,[origin(1)+45 origin(2)+5 200 26],handles.colors.togglebuttonbg,cdata,'    Enable 3D Graph Rotation',@rotate3dbutton_callback,handles.rotater);
% set(rotatebutton,'tag','rotate3dtoggle','visible','off');
%






%% group items and finish up
handles.tabobjects=[datasettext xaxistext yaxistext colortext datasetmenu xaxismenu yaxismenu colormenu,...
    analysistext projecttext analysismenu dataseriestext optionstext ,...
    changeunitsbutton zaxistext zaxismenu currentpointcheck];
%handles.tabobjects=[handles.tabobjects h];



handles.activetab='view';

guidata(src,handles);
% update menus to hide excluded vars


%% Here be callbacks:%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function datasetmenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

udata.view.dataset=get(src,'value');

set(handles.fakeax(handles.activeindex),'userdata',udata);
handles.graphdataset(handles.activeindex)=get(src,'value');
guidata(src,handles);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function analysismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
handles.graphanalysis(handles.activeindex)=get(src,'value');
guidata(src,handles);

udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.analysis=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function xaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
inputvars=get(src,'string');
thisvar=inputvars(get(src,'value'));

udata.view.x=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function yaxismenu_callback(src,eventdata) %#ok<INUSD>

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
inputvars=get(src,'string');
thisvar=inputvars(get(src,'value'));

udata.view.y=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function zaxismenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
respvars=get(src,'string');
thisvar=respvars(get(src,'value'));

udata.view.z=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function colormenu_callback(src,eventdata) %#ok<INUSD>
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

allvars=handles.allnames{udata.view.dataset};
respvars=get(src,'string');
thisvar=respvars(get(src,'value'));

udata.view.c=find(ismember(allvars,thisvar));

set(handles.fakeax(handles.activeindex),'userdata',udata);

ravecreatesurfaceprofiler(src,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pprofclick(hObject,eventdata) %#ok<INUSD>
handles=guidata(hObject);

set(handles.fig,'windowbuttonmotionfcn',{@pprofslide,handles.fig})
set(handles.fig,'windowbuttonupfcn',{@pprofdone,handles.fig})

function pprofslide(hObject,eventdata,fig) %#ok<INUSL>
handles=guidata(fig);
udata=get(handles.fakeax(handles.activeindex),'userdata');


magicbox=findobj(handles.tabobjects,'tag','magicbox');
magicbox=get(magicbox,'userdata');

thisvar=get(gco,'userdata');
thistype=handles.datatype{udata.view.dataset}{thisvar};
allowablevalues=handles.discretevalues{udata.view.dataset}{udata.view.analysis}{thisvar};


if ~isempty(hObject) %if this function is called as a callback: (get mouse location and slide bars)
    clicked=get(magicbox.ax,'currentpoint');
    val=clicked(1,1);
    
    %move marker within bounds
    if val>0.73
        val=0.73;
    elseif val<0.43
        val=0.43;
    end
    
    %round to nearest allowable point:
    if ~any(strcmp(thistype,{'constant','continuous'}))
        
        allowed=linspace(.43,.73,numel(allowablevalues));
        val=allowed(abs(allowed-val)==min(abs(allowed-val)));
        val=val(1); %in case above line has 2 mins.
        newval=allowablevalues(abs(allowed-val)==min(abs(allowed-val)));
        
    else
        
        range=magicbox.ranges(thisvar,:);
        if range(1)-range(2)==0;return;end %avoids errors with constant variables.
        newval=range(1)+((val-0.43)/0.3)*(range(2)-range(1));
        
    end
    
    set(gco,'xdata',val)
    
    %update text values
    
    %make current value texts:
    if ~any(strcmp(thistype,{'string','logical'}))
        valtext=strtrim(sprintf('%5.5g',newval));
    elseif strcmp(thistype,'string')
        valtext=handles.discretevalues{d}{a}{xcol(index)}{newval};
    else %logical
        if newval
            valtext=handles.prefs.logicaltrue;
        else
            valtext=handles.prefs.logicalfalse;
        end
    end
    
    
    set(magicbox.valtexts(thisvar),'string',valtext,'color',[0 0 0]);
    
end


handles.xdials{udata.view.dataset}{udata.view.analysis}(thisvar)=newval;
guidata(handles.fig,handles);


% UPDATE GRAPH
raveupdatesurfaceprofiler(handles.fig,[]);

%update on slide if desired:
if handles.prefs.alwaysupdate && ~handles.prefs.alwaysrasterize
    raveupdateanalysis(handles.fig,[],'xdials',handles.activeindex)
end

function pprofdone(hObject,eventdata,fig) %#ok<INUSL>
handles=guidata(fig);
set(handles.fig,'windowbuttonmotionfcn',@ravedefaultwindowbuttonmotionfcn)
set(handles.fig,'windowbuttonupfcn','')

raveupdateanalysis(handles.fig,[],'xdials',handles.activeindex);


function pprof_scroll(src,eventdata) %#ok<INUSD>
%this is the callback for scrolling the magic box in pprof.
handles=guidata(src);

magicbox.ax=findobj(handles.tabobjects,'tag','magicbox');

set(magicbox.ax,'ylim',[get(src,'value') get(src,'value')+1]);


function changevaltexts(src,ev)

handles=guidata(src);


set(src,'editing','on');

oldfun=get(handles.fig,'windowbuttondownfcn');
set(0,'userdata',src);

set(handles.fig,'windowbuttondownfcn',{@changevaltextsdone,oldfun});

function changevaltextsdone(src,ev,oldfun)

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

set(handles.fig,'windowbuttondownfcn',oldfun) %do this first in case of errors later.


d=udata.view.dataset;
a=udata.view.analysis;

txt=get(0,'userdata');

ranges=[handles.minlimit{d}{a}' handles.maxlimit{d}{a}'];
newval=str2double(get(txt,'string'));

%convert values to slider range:

thisvar=get(txt,'userdata');

%normalize xdials to range used in magicbox:
startvalue=(newval-ranges(thisvar,1)')./(ranges(thisvar,2)'-ranges(thisvar,1)')*.3+.43;

oor=false;
if startvalue<.43
    startvalue=.43;
    oor=true;
elseif startvalue>.73
    startvalue=.73;
    oor=true;
end

if oor
    set(txt,'color',[1 0 0])
else
    set(txt,'color',[0 0 0])
end

thisblob=findobj(get(txt,'parent'),'type','line','userdata',thisvar);
set(thisblob,'xdata',startvalue);

handles.xdials{d}{a}(thisvar)=newval;

guidata(handles.fig,handles);

raveupdatesurfaceprofiler(handles.fig,[]);
raveupdateanalysis(handles.fig,[],'xdials',handles.activeindex);



function showcurrentpoint_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.view.showcurrentpoint=get(src,'value');
set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatesurfaceprofiler(handles.fig,[]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function rotatebutton_callback(src,ev)
handles=guidata(src);
handles.rotater=get(src,'value');
guidata(handles.fig,handles);














