function boxselectscattergrad3D(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

ai=find(handles.allgraphs==src);

udata=get(handles.fakeax(ai),'userdata'); %#ok<FNDSB>
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:
z = get(src,'CameraTarget') - get(src,'CameraPosition');

xlim=get(src,'xlim');
ylim=get(src,'ylim');
zlim=get(src,'zlim');
xscale=xlim(2)-xlim(1);
yscale=ylim(2)-ylim(1);
zscale=zlim(2)-zlim(1);
handles.temp.xscale=xscale;
handles.temp.yscale=yscale;
handles.temp.zscale=zscale;

z = z./[xscale,yscale,zscale];

z = z./norm(z,2);
u = [0,0,1];
u = u - dot(z,u).*z;
u = u./norm(u);
v = cross(u,z);

handles.temp.u=u;
handles.temp.v=v;

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
zclick=clicked(1,3,1);
point=[xclick yclick zclick];
point = point./[xscale,yscale,zscale];

%project onto u1 v1 plane:
u1 = dot(point,u);
v1 = dot(point,v);

handles.temp.xpoints=xclick;
handles.temp.ypoints=yclick;
handles.temp.zpoints=zclick;
handles.temp.upoints=u1;
handles.temp.vpoints=v1;

xyzdata=u1*u + v1*v;



%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual','zlimmode','manual');

%fill color:
handles.temp.selection=line(xyzdata(1),xyzdata(2),xyzdata(3),'linewidth',1,'color',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','clipping','off');


uistack(handles.temp.selection,'bottom');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'tag','main');

handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x)/xscale;
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y)/yscale;
handles.temp.zdata=handles.alldata{udata.view.dataset}(:,udata.view.z)/zscale;

%project this data into uv plane:
pointdata=[handles.temp.xdata handles.temp.ydata handles.temp.zdata];

handles.temp.udata=pointdata*u';
handles.temp.vdata=pointdata*v';

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@sizebox);
set(handles.fig,'WindowButtonUpFcn',@sizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

handles.lastd=udata.view.dataset;
handles.lasta=udata.view.analysis;

guidata(src,handles);

function sizebox(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

clicked = get(handles.allgraphs(ai),'CurrentPoint');
xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
zclick=clicked(1,3,1);
point=[xclick yclick zclick];

xscale = handles.temp.xscale;
yscale = handles.temp.yscale;
zscale = handles.temp.zscale;

point = point./[xscale,yscale,zscale];

u=handles.temp.u;
v=handles.temp.v;

%project onto u1 v1 plane:
u2 = dot(point,u);
v2 = dot(point,v);

u1 = handles.temp.upoints(1);
v1 = handles.temp.vpoints(1);

u3=u2;
u4=u1;

v3 = v2;
v4 = v2;

handles.temp.upoints=[u1;u2;u3;u4;u1];
handles.temp.vpoints=[v1;v1;v3;v4;v1];

xyzdata=bsxfun(@times,repmat(handles.temp.upoints,1,3),u) + bsxfun(@times,repmat(handles.temp.vpoints,1,3),v);
xyzdata = xyzdata*diag([xscale,yscale,zscale]);

% *handles.temp.yscale

% replot the newly extended lasso
%set(handles.temp.selection,'xdata',handles.temp.xpoints,'ydata',handles.temp.ypoints,'zdata',handles.tmep.zpoints)
set(handles.temp.selection,'xdata',xyzdata(:,1),'ydata',xyzdata(:,2),'zdata',xyzdata(:,3));

%determine which points are in this region:
%inpoints=find(inpolygon(handles.temp.xdata,handles.temp.ydata,handles.temp.xpoints,handles.temp.ypoints));


try
    inpoints=raveinsidepoly(handles.temp.udata,handles.temp.vdata,handles.temp.upoints,handles.temp.vpoints);
catch %#ok<CTCH>
    inpoints=inpolygon(handles.temp.udata,handles.temp.vdata,handles.temp.upoints,handles.temp.vpoints);
end



inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};
if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(inpoints))) ' points selected'])

guidata(handles.fig,handles); %update handles.temp...
updatescattergrad3Disselected(src,ai,handles.isselected{udata.view.dataset}{udata.view.analysis})


function sizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode,'zlimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');

inpoints=inpolygon(handles.temp.udata,handles.temp.vdata,handles.temp.upoints,handles.temp.vpoints);
inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};
if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

delete(handles.temp.selection);

set(handles.fakeax(ai),'userdata',udata);
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',[],udata.view.dataset,udata.view.analysis);
