function lassoselectscattergrad3D(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

ai=find(handles.allgraphs==src);

udata=get(handles.fakeax(ai),'userdata');
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:
z = get(src,'CameraTarget') - get(src,'CameraPosition');
z = z./norm(z,2);
u = rand(1,3);
u = u - dot(z,u).*z;
u = u./norm(u);
v = cross(u,z);

handles.temp.u=u;
handles.temp.v=v;

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
zclick=clicked(1,3,1);
point=[xclick yclick zclick];

%project onto u1 v1 plane:
u1 = dot(point,u);
v1 = dot(point,v);

handles.temp.xpoints=xclick;
handles.temp.ypoints=yclick;
handles.temp.zpoints=zclick;
handles.temp.upoints=u1;
handles.temp.vpoints=v1;

xyzdata=u1*u + v1*v;

%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual','zlimmode','manual');

%fill color:
handles.temp.selection=line(xyzdata(1),xyzdata(2),xyzdata(3),'linewidth',1,'color',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','clipping','off');

uistack(handles.temp.selection,'bottom');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'tag','main');

handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);
handles.temp.zdata=handles.alldata{udata.view.dataset}(:,udata.view.z);

%project this data into uv plane:
pointdata=[handles.temp.xdata handles.temp.ydata handles.temp.zdata];

handles.temp.udata=pointdata*u';
handles.temp.vdata=pointdata*v';


handles.temp.wasselected=handles.isselected{udata.view.dataset}{udata.view.analysis};


%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@sizelasso);
set(handles.fig,'WindowButtonUpFcn',@sizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

handles.lastd=udata.view.dataset;
handles.lasta=udata.view.analysis;

guidata(src,handles);

function sizelasso(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');

clicked = get(handles.allgraphs(ai),'CurrentPoint');
xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
zclick=clicked(1,3,1);
point=[xclick yclick zclick];

u=handles.temp.u;
v=handles.temp.v;

%project onto u1 v1 plane:
u1 = dot(point,u);
v1 = dot(point,v);

handles.temp.xpoints=[handles.temp.xpoints,xclick];
handles.temp.ypoints=[handles.temp.ypoints,yclick];
handles.temp.zpoints=[handles.temp.zpoints,zclick];

handles.temp.upoints=[handles.temp.upoints;u1];
handles.temp.vpoints=[handles.temp.vpoints;v1];

xyzdata=bsxfun(@times,repmat(handles.temp.upoints,1,3),u) + bsxfun(@times,repmat(handles.temp.vpoints,1,3),v);

% replot the newly extended lasso
set(handles.temp.selection,'xdata',[xyzdata(:,1);xyzdata(1,1)],'ydata',[xyzdata(:,2);xyzdata(1,2)],'zdata',[xyzdata(:,3);xyzdata(1,3)]);

%determine which points are in this region:
try
    inpoints=raveinsidepoly(handles.temp.udata,handles.temp.vdata,handles.temp.upoints,handles.temp.vpoints);
catch
    inpoints=inpolygon(handles.temp.udata,handles.temp.vdata,handles.temp.upoints,handles.temp.vpoints);
end

inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};
if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.temp.wasselected;
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.temp.wasselected;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

guidata(handles.fig,handles); %update handles.temp...
updatescattergrad3Disselected(src,ai,handles.isselected{udata.view.dataset}{udata.view.analysis})

function sizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);
set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)



%store indices of selected points.
try
    inpoints=raveinsidepoly(handles.temp.udata,handles.temp.vdata,handles.temp.upoints,handles.temp.vpoints);
catch
    inpoints=inpolygon(handles.temp.udata,handles.temp.vdata,handles.temp.upoints,handles.temp.vpoints);
end


inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};
if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

delete(handles.temp.selection);

set(handles.fakeax(ai),'userdata',udata);
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',[],udata.view.dataset,udata.view.analysis);
