function ravemouseoverscattergrad3Ddata(src,ev,ai)

return

%persistent handles udata

handles=guidata(src);

if handles.prefs.mouseoverdelay>0
    set(handles.mousetimer,'TimerFcn',{@processmouseover,handles,ai})
    stop(handles.mousetimer);
    start(handles.mousetimer);
else %process immediately
    processmouseover(handles,ai);    
end

function processmouseover(src,ev,handles,ai)
udata=get(handles.fakeax(ai),'userdata');

%show mouseovertext:
loc=get(handles.allgraphs(ai),'currentpoint');

xclick=loc(1,1);
yclick=loc(1,2);

xcol=udata.view.x;
ycol=udata.view.y;

idx=ravefindclosestpoint2D(xclick,yclick,handles.alldata{udata.view.dataset}(:,[xcol ycol]),handles.allgraphs(ai));

%calculate pixel offsets:

pos=get(handles.allgraphs(ai),'position');
xlim=get(handles.allgraphs(ai),'xlim');
ylim=get(handles.allgraphs(ai),'ylim');

xpix=(xlim(2)-xlim(1))./pos(3);
ypix=(ylim(2)-ylim(1))./pos(4);

xoff=6;
yoff=6;

d=udata.view.dataset;




%show highlight marker:
%determine size:

if udata.view.s==0
    s=sqrt(udata.format.minmarkersize);
end

set(udata.explore.mouseoverhandles(1),'xdata',handles.alldata{d}(idx,xcol),'ydata',handles.alldata{d}(idx,ycol),'markersize',s,'visible','on');




%show text label:
set(udata.explore.mouseoverhandles(2),'position',handles.alldata{udata.view.dataset}(idx,[xcol ycol])+[(xoff-1)*xpix yoff*ypix])
set(udata.explore.mouseoverhandles(3),'position',handles.alldata{udata.view.dataset}(idx,[xcol ycol])+[(xoff+1)*xpix yoff*ypix])
set(udata.explore.mouseoverhandles(4),'position',handles.alldata{udata.view.dataset}(idx,[xcol ycol])+[xoff*xpix yoff*ypix])
if handles.rowlabelcolumn{d}==0
    set(udata.explore.mouseoverhandles(2:end),'visible','on','string',strtrim(sprintf('%8.0f',find(idx))));
else
    switch handles.datatype{d}{handles.rowlabelcolumn}
        case 'string'
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string','name');
        otherwise
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string','notstring');
    end
end

if udata.view.c>0 && udata.format.colorbar
    %make mouseover pointers:
    
    legdata=get(handles.fakerax(ai),'userdata');
    aaa=findobj(legdata,'tag','Colorbar');
    pos=get(aaa,'position');
    ylim=get(aaa,'ylim');
    xlim=get(aaa,'xlim');
    
    clim=[min(handles.alldata{d}(:,udata.view.c)) max(handles.alldata{d}(:,udata.view.c))];
    
    
    %determine current c value:
    thisvalue=handles.alldata{d}(idx,udata.view.c);
    thiscoord=interp1(clim,ylim,thisvalue);
    pixels=pos(3)./(xlim(2)-xlim(1)); %pixels per unit
    
    %make triangle patch at this value:
  %  p = patch([xlim(1)-7/pixels xlim(1)-7/pixels xlim(1)-1/pixels],[thiscoord-1.5 thiscoord+1.5 thiscoord],get(handles.fakerax(ai),'color'),'parent',aaa,'tag','mouseovervalue');
 %   t = text(xlim(2)+3/pixels,thiscoord,sprintf('%5.5g',thisvalue),'color',[0 0 0],'parent',aaa,'tag','mouseovervaluetxt','fontsize',handles.prefs.fonts.graphsize,'fontname',handles.prefs.fonts.graph);
    
    set(udata.explore.cbarmouseovervalue,'ydata',[thiscoord-1 thiscoord+1  thiscoord],'visible','on');
    set(udata.explore.cbarmouseovertext,'position',[xlim(2)+3/pixels,thiscoord],'visible','on','string',sprintf('%5.5g',thisvalue));
 %   set(handles.fakeax(ai),'userdata',udata);
end
