function formattabsliders(src,eventdata)
%rave format tab.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %move swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0);
set(handles.backtablines,'xdata',x,'ydata',y);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1);
set(handles.fronttablines,'xdata',x,'ydata',y)

origin=get(handles.tabaxes,'position');


%% clear existing tab
delete(handles.tabobjects)

%% do work

graphtext=text(.15-.10317,.97*1.0317-.0317,'Appearance','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);





facecheck=uicontrol('position',[origin(1)+38+15-30 origin(2)+545-15 150 20],'style','radiobutton',...
    'string','','value',~udata.format.usevariablecolors,'backgroundcolor',handles.colors.tabbg,...
    'callback',@facecheck_callback,'tag','facecheck');
facetext=uicontrol('position',[origin(1)+55+15-30 origin(2)+542-15 150 20],...
    'style','text','string','Face Color:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');

facecolor=uicontrol('position',[origin(1)+145-6+15-30 origin(2)+542-15 25 25],...
    'style','pushbutton','string','','backgroundcolor',udata.format.facecolor,'value',0,...
    'callback',@faceblob_callback);

ortext=uicontrol('position',[origin(1)+85+15-30 origin(2)+565-15 150 20],...
    'style','text','string','or','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','normal');

varcolorscheck=uicontrol('position',[origin(1)+38+15-30 origin(2)+587-15 150 20],'style','radiobutton',...
    'string','','value',udata.format.usevariablecolors,'backgroundcolor',handles.colors.tabbg,...
    'callback',@varcheck_callback,'tag','varcolors');
varcolorstext=uicontrol('position',[origin(1)+55+15-30 origin(2)+584-15 150 20],...
    'style','text','string','Use Variable Colors','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');












%% group items and finish up
handles.tabobjects=[graphtext varcolorstext varcolorscheck facecheck facetext facecolor ortext];

handles.activetab='format';

set(handles.infobar,'string','');

guidata(src,handles);


function facecheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
varcolors=findobj(handles.tabobjects,'tag','varcolors');
set(varcolors,'value',0);
udata.format.usevariablecolors=false;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%update:
ravecreatesliders(handles.fig,[]);


function varcheck_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
facecheck=findobj(handles.tabobjects,'tag','facecheck');
set(facecheck,'value',0);
udata.format.usevariablecolors=true;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%update:
ravecreatesliders(handles.fig,[]);











function faceblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.facecolor,'Choose a marker fill color');
set(src,'backgroundcolor',newcolor);
udata.format.facecolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);

%update:
ravecreatesliders(handles.fig,[]);




