function ravearrangeobjectssliders(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%charwidths=handles.prefs.fonts.graphwidths;
%maxw=max(charwidths(48:57));

[maxw,fontheight]=ravecalculatestringlength('0',handles.prefs.fonts.graph,handles.prefs.fonts.graphsize,'plain',handles.axiscanvas);


%raveresizeaxes(src,[],handles.activeindex)
axpos=getpixelposition(handles.activegraph);
nvars=numel(udata.view.x);

rpix=14.7; %pixels per row of text.
tpix=rpix*(nvars+1); %total number of pixels needed to display all vars.
dpix = axpos(4); %number of pixels visible at any time.
slpos=[axpos(1)+axpos(3)+12*maxw+5 axpos(2)-1 17 axpos(4)+1];
ndisp=floor(axpos(4)/rpix);

set(handles.activegraph,'xlim',[0.43 0.73]);

set(handles.activegraph,'ylim',[1 ndisp*rpix]);
%set(handles.fakeax(handles.activeindex),'ylim',[1 ndisp*rpix]);
%set(handles.fakeax(handles.activeindex),'pos',[axpos(1)-10 axpos(2) axpos(3)+20 axpos(4)]);

pixperlim=axpos(3)./0.30;

varposses=get(udata.view.vartexts,'position');
if iscell(varposses);varposses=cell2mat(varposses);end
varposses(:,1)=0.43 - 10./pixperlim;
varposses=mat2cell(varposses,ones(size(varposses,1),1),3);
set(udata.view.vartexts,{'position'},varposses);

valposses=get(udata.view.valtexts,'position');
if iscell(valposses);valposses=cell2mat(valposses);end
valposses(:,1)=0.73 + 10./pixperlim;
valposses=mat2cell(valposses,ones(size(valposses,1),1),3);
set(udata.view.valtexts,{'position'},valposses);


delete(udata.view.scroll)
vscroll=drawvscroll(handles.wspanel,handles.activegraph,slpos,0,tpix,dpix,tpix,@sliderscroll,1);
udata.view.scroll=vscroll;
set(handles.fakeax(handles.activeindex),'userdata',udata);





