function preferencesliderschangevaltexts(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);


set(src,'editing','on');

oldfun=get(handles.fig,'windowbuttondownfcn');
set(0,'userdata',src);

set(handles.fig,'windowbuttondownfcn',{@changevaltextsdone,oldfun});

function changevaltextsdone(src,ev,oldfun)

handles=guidata(src);
try
ai=find(handles.allgraphs==get(get(0,'userdata'),'parent'));
catch %#ok<CTCH>
    return
end
udata=get(handles.fakeax(ai),'userdata'); %#ok<FNDSB>

set(handles.fig,'windowbuttondownfcn',oldfun) %do this first in case of errors later.

d=udata.view.dataset;
a=udata.view.analysis;

txt=get(0,'userdata');

newval=str2double(get(txt,'string'));

%convert values to slider range:

thisvar=get(txt,'userdata');

%normalize xdials to range used in magicbox:
startvalue=(sqrt(newval)).*0.3+.43;

oor=false; %oor=out of range
if startvalue<.43
    startvalue=.43;
    oor=true;
elseif startvalue>.73
    startvalue=.73;
    oor=true;
end

if oor
    set(txt,'color',[1 0 0])
else
    set(txt,'color',[0 0 0])
end

thisblob=findobj(get(txt,'parent'),'type','line','userdata',thisvar);
set(thisblob,'xdata',startvalue);

handles.preferences{d}(thisvar)=newval;

guidata(handles.fig,handles);

%raveupdatesurfaceprofiler(handles.fig,[]);
%raveupdateanalysis(handles.fig,[],'xdials',[]);







