function ravearrangeobjectsfilter(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

%raveresizeaxes(src,[],handles.activeindex)
axpos=get(handles.activegraph,'position');

[maxw,fontheight]=ravecalculatestringlength('0',handles.prefs.fonts.graph,handles.prefs.fonts.graphsize,'plain',handles.axiscanvas);

%inset=[10*maxw 5 10*maxw+30 5];

%position scroll bar +12 chars to the right of this:
slpos=[axpos(1)+axpos(3)+12*maxw+5 axpos(2)-1 17 axpos(4)+1];


nvars=numel(udata.view.x);
rpix=14.7; %pixels per row of text.
tpix=rpix*(nvars+1); %total number of pixels needed to display all vars.
dpix = axpos(4); %number of pixels visible at any time.
ndisp=floor(axpos(4)/rpix);

set(handles.activegraph,'xlim',[0.43 0.73]);

pixperlim=axpos(3)./0.30;


%position variable names:

varposses=get(udata.view.vartexts,'position');
if iscell(varposses);varposses=cell2mat(varposses);end
varposses(:,1)=0.43 - (10*maxw)./pixperlim;
varposses=mat2cell(varposses,ones(size(varposses,1),1),3);
set(udata.view.vartexts,{'position'},varposses);

valposses=get(udata.view.minvaltexts,'position');
if iscell(valposses);valposses=cell2mat(valposses);end
valposses(:,1)=0.43 - 10./pixperlim;
valposses=mat2cell(valposses,ones(size(valposses,1),1),3);
set(udata.view.minvaltexts,{'position'},valposses);

valposses=get(udata.view.maxvaltexts,'position');
if iscell(valposses);valposses=cell2mat(valposses);end
valposses(:,1)=0.73 + 10./pixperlim;
valposses=mat2cell(valposses,ones(size(valposses,1),1),3);
set(udata.view.maxvaltexts,{'position'},valposses);



set(handles.activegraph,'ylim',[1 ndisp*rpix]);
delete(udata.view.scroll)
vscroll=drawvscroll(handles.wspanel,handles.activegraph,slpos,0,tpix,dpix,tpix,@sliderscroll,1);
udata.view.scroll=vscroll;
set(handles.fakeax(handles.activeindex),'userdata',udata);
