function ravecreatediscretefilter(src,ev)
%create discrete data filter on workspace.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');

targetaxes=handles.activegraph; %=handles.activegraph
x=udata.view.x;
a=udata.view.analysis;
d=udata.view.dataset; %data set index

%clear old filter
if ishandle(handles.fakerax(handles.activeindex))
    delete(handles.fakerax(handles.activeindex));  %uipanel of old filter
end

guidata(handles.fig,handles);
delete(udata.view.scroll);
udata.view.scroll=[];
set(handles.fakeax(handles.activeindex),'userdata',udata);

if udata.view.x==0;
    return
end

axpos=get(targetaxes,'position');
string=handles.discretevalues{d}{a}{x};

if ~iscell(string);string=num2cell(string);end

for s=1:numel(string);
    if ~ischar(string{s})
        string{s}=num2str(string{s});
    end
end

switch handles.datatype{d}{x}
    case {'string','discrete','integer','logical'}
        value=handles.discretefilter{d}{a}{x};
    otherwise
        value=[];
end

if isempty(value) %nondiscretevariable selected
    return
end

%get colors:
axescolors=handles.colors.axes{udata.format.bg};
bgcolor=axescolors(2,:);
txt=axescolors(5,:);

[ax,vscroll]=drawlistbox(handles.wspanel,axpos,string,100,1,value,1,'line',[.5 .5 .5],udata.format.rowheight,@applydiscretefilter);
tax=findobj(ax,'tag','tax');
ttax=findobj(ax,'tag','ttax');

txts=get(tax,'userdata');
set(txts,'fontname',handles.prefs.fonts.graph,'fontsize',handles.prefs.fonts.graphsize,'color',txt);

alpha=[0.299 0.587 0.114]'*udata.format.selectedcolor;
if alpha<0.5
    set(txts(value),'color',[1 1 1])
else
    set(txts(value),'color',[0 0 0])
end

%store new object handles:
handles.fakerax(handles.activeindex)=ax;
guidata(handles.fig,handles);
udata.view.scroll=vscroll;
udata.view.tax=tax;
udata.view.ttax=ttax;
set(handles.fakeax(handles.activeindex),'userdata',udata)

%ravearrangeobjectsdiscretefilter(handles.fig,[]);
raveresizeaxes(handles.fig,[],handles.activeindex);
%ravearrangeobjects(handles.fig,[])
clear ravearrangeobjects

function applydiscretefilter(src,ev,value)
handles=guidata(src);
ai=ev;
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;
x=udata.view.x;

newval=false(size(handles.discretefilter{d}{a}{x}));
newval(value)=true;
handles.discretefilter{d}{a}{x}=newval;

switch handles.datatype{d}{x}
    
    case 'string'
        if any(newval)
            handles.minfilter{d}{a}(x)=find(newval,1,'first');
            handles.maxfilter{d}{a}(x)=find(newval,1,'last');
        end
    case {'discrete','integer','logical'}
        if any(newval)
            discretevalues=handles.discretevalues{d}{a}{x};
            handles.minfilter{d}{a}(x)=discretevalues(find(newval,1,'first'));
            handles.maxfilter{d}{a}(x)=discretevalues(find(newval,1,'last'));
        end
end

guidata(handles.fig,handles);
handles.isfiltered{d}{a}=ravecalculatefilteredstate(handles.fig,[],d,a);
guidata(handles.fig,handles);

raveupdateanalysis(handles.fig,[],'isfiltered',ai,udata.view.dataset,udata.view.analysis);



