function ravelinkgraphaxes(src,ev,ai,idx)
%link the graph axes with index ai to the graph with index idx. This
%function is only used when the linked graph is changed, and it resets most
%of the control properties to their default values.
%EVEN MORE CRAZIER VERSION

handles=guidata(src);
udata=get(handles.fakeax(ai),'userdata');

idx=udata.view.linkedindex;

delete(udata.view.X.menuobj);
delete(udata.view.Y.menuobj);
delete(udata.view.Z.menuobj);
delete(udata.view.C.menuobj);
delete(udata.view.S.menuobj);
delete(udata.view.X.menujobj);
delete(udata.view.Y.menujobj);
delete(udata.view.Z.menujobj);
delete(udata.view.C.menujobj);
delete(udata.view.S.menujobj);

udata.view.X.menuobj=[];
udata.view.Y.menuobj=[];
udata.view.Z.menuobj=[];
udata.view.C.menuobj=[];
udata.view.S.menuobj=[];
udata.view.X.menujobj=[];
udata.view.Y.menujobj=[];
udata.view.Z.menujobj=[];
udata.view.C.menujobj=[];
udata.view.S.menujobj=[];

if idx==0 %reset control.
    oldindex=handles.activeindex;
    handles.activeindex=ai;
    guidata(handles.fig,handles);

    raveinitializegraphaxes(handles.fig,[]);
    handles=guidata(handles.fig);
    handles.activeindez=oldindex;
    guidata(handles.fig,handles);
    return
end

uuu=get(handles.fakeax(idx),'userdata');
udata.view.dataset=uuu.view.dataset;
udata.view.analysis=uuu.view.analysis;


delete(udata.view.tabobjects(ishandle(udata.view.tabobjects)));

%pure insanity:
if ~ishandle(handles.allgraphs(idx))
    udata.view.linkedindex=0;

    return
end

type=get(handles.allgraphs(idx),'userdata');

activetab=handles.activetab;
originalgraph=handles.activegraph;
originalidx=handles.activeindex;
originaltype=handles.activetype;

handles.activegraph=handles.allgraphs(idx);
handles.activeindex=idx;
handles.activetype=type;
guidata(handles.fig,handles);

viewtab(handles.fig,[]);

handles=guidata(handles.fig);

xmenu=findobj(handles.tabobjects,'type','uicontrol','tag','xaxismenu');
ymenu=findobj(handles.tabobjects,'type','uicontrol','tag','yaxismenu');
zmenu=findobj(handles.tabobjects,'type','uicontrol','tag','zaxismenu');
cmenu=findobj(handles.tabobjects,'type','uicontrol','tag','colormenu','-or','tag','cmenu','-or','tag','caxismenu');
smenu=findobj(handles.tabobjects,'type','uicontrol','tag','sizemenu','-or','tag','smenu','-or','tag','saxismenu');

xtext=findobj(handles.tabobjects,'type','uicontrol','tag','xaxistext');
ytext=findobj(handles.tabobjects,'type','uicontrol','tag','yaxistext');
ztext=findobj(handles.tabobjects,'type','uicontrol','tag','zaxistext');
ctext=findobj(handles.tabobjects,'type','uicontrol','tag','colortext','-or','tag','ctext','-or','tag','caxistext');
stext=findobj(handles.tabobjects,'type','uicontrol','tag','sizetext','-or','tag','stext','-or','tag','saxistext');

if ~isempty(xmenu)
    newxmenu=copyobj(xmenu,handles.boneyard);
    hasxmenu=true;
    if ~isempty(xtext);udata.view.X.label=get(xtext,'string');end
else
    newxmenu=[];
    hasxmenu=false;
end

if ~isempty(ymenu)
    newymenu=copyobj(ymenu,handles.boneyard);
    hasymenu=true;
    if ~isempty(ytext);udata.view.Y.label=get(ytext,'string');end
else
    newymenu=[];
    hasymenu=false;
end

if ~isempty(zmenu)
    newzmenu=copyobj(zmenu,handles.boneyard);
    haszmenu=true;
    if ~isempty(ztext);udata.view.Z.label=get(ztext,'string');end
else
    newzmenu=[];
    haszmenu=false;
end

if ~isempty(cmenu)
    newcmenu=copyobj(cmenu,handles.boneyard);
    hascmenu=true;
    if ~isempty(ctext);udata.view.C.label=get(ctext,'string');end
else
    newcmenu=[];
    hascmenu=false;
end

if ~isempty(smenu)
    newsmenu=copyobj(smenu,handles.boneyard);
    hassmenu=true;
    if ~isempty(stext);udata.view.S.label=get(stext,'string');end
else
    newsmenu=[];
    hassmenu=false;
end

handles.activegraph=originalgraph;
handles.activeindex=originalidx;
handles.activetype=originaltype;
guidata(handles.fig,handles);

eval([activetab,'tab(handles.fig,[]);']);
handles=guidata(handles.fig);



udata.view.ispresent=[hasxmenu hasymenu haszmenu hascmenu hassmenu];
dothese=find([hasxmenu hasymenu haszmenu hascmenu hassmenu]);

udata.view.X.string='';
udata.view.Y.string='';
udata.view.Z.string='';
udata.view.C.string='';
udata.view.S.string='';
udata.view.tabobjects=[newxmenu newymenu newzmenu newcmenu newsmenu];

strngz={'X';'Y';'Z';'C';'S'};

delete(udata.view.X.menuobj);
delete(udata.view.Y.menuobj);
delete(udata.view.Z.menuobj);
delete(udata.view.C.menuobj);
delete(udata.view.S.menuobj);


for g=1:numel(dothese)
    
    menu=udata.view.tabobjects(g);
    
    q=strngz{dothese(g)};
    
    udata.view.(q).style=get(menu,'style');
    udata.view.(q).string=get(menu,'string');
    udata.view.(q).value=get(menu,'value');
    udata.view.(q).variables=1:numel(udata.view.(q).string);
    
    max=get(menu,'max');
    if strcmp(udata.view.(q).style,'listbox') && max>1
        udata.view.(q).allowmulti=1;
    else
        udata.view.(q).allowmulti=0;
    end
end

udata.view.X.menutext=[];
udata.view.X.menuobj=[];
udata.view.Y.menutext=[];
udata.view.Y.menuobj=[];
udata.view.Z.menutext=[];
udata.view.Z.menuobj=[];
udata.view.C.menutext=[];
udata.view.C.menuobj=[];
udata.view.S.menutext=[];
udata.view.S.menuobj=[];

%udata.view.X.callback=get(xmenu,'callback');
%udata.view.X.menujobj=jxmenu;


set(handles.fakeax(ai),'userdata',udata);

