function ravecreaterotate3dbutton(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
%get format inputs:
udata=get(handles.fakeax(handles.activeindex),'userdata');


targetaxes=handles.activegraph; %=handles.activegraph
xcol=udata.view.x;
a=udata.view.analysis;
d=udata.view.dataset; %data set index

set(targetaxes,'visible','off')
set(handles.fakeax(handles.activeindex),'visible','off')
set(handles.fakerax(handles.activeindex),'visible','off')

origin=get(targetaxes,'position');

%make cdata
try
    idata=imread(fullfile(matlabroot,'/toolbox/matlab/icons/tool_rotate_3d.png'),'backgroundcolor',handles.colors.togglebuttonbg);
    idata=double(idata)./(255^2);   
    idata(idata>1)=1;

    cdata=ones(26,200,3);
    cdata(:,:,1)=cdata(:,:,1).*handles.colors.togglebuttonbg(1);
    cdata(:,:,2)=cdata(:,:,2).*handles.colors.togglebuttonbg(2);
    cdata(:,:,3)=cdata(:,:,3).*handles.colors.togglebuttonbg(3);
    cdata(5:20,7:22,:)=idata;
    cdata=uint8(cdata.*255);
catch
    cdata=[]; 
end
    
%make pixel coordinates:
set(targetaxes,'xlim',[1 origin(3)],'ylim',[1 origin(4)],'xticklabel','','yticklabel','');
thebutton=drawtogglebutton(handles.wspanel,[origin(1)+5 origin(2)+5 200 26],handles.colors.togglebuttonbg,cdata,'    Enable 3D Graph Rotation',@rotate3dbutton_callback,handles.rotater);
set(thebutton,'userdata',handles.activeindex,'tag','rotate3dtoggle');

udata.view.thebutton=thebutton;

set(handles.fakeax(handles.activeindex),'userdata',udata);

raveresizeaxes(handles.fig,[],handles.activeindex);
clear ravearrangeobjects


