function boxselectline(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);

src=ancestor(src,'axes');
ai=find(handles.allgraphs==src);


udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.startx=xclick;
handles.temp.starty=yclick;

handles.temp.selection=rectangle('position',[xclick yclick eps eps],'linewidth',1,'edgecolor',[1 .5 0],...
    'parent',src,'hittest','off','facecolor','none','clipping','on');
%maindata=findobj(handles.activegraph,'tag','main');
%set(maindata,'visible','off');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'type','line','marker','none');

if udata.view.x>0
    x=handles.alldata{udata.view.dataset}(:,udata.view.x);
else
    x=(1:size(handles.alldata{udata.view.dataset},1))';
end

% %sort data:
% if udata.view.s==0 || (udata.view.s==-1 && udata.view.x==0);
%     %no sorting, do nothing
%     idx=1:size(handles.alldata{d},1);
% elseif udata.view.s==-1
%     s=udata.view.x;
%     [junk,idx]=sort(handles.alldata{d}(:,s)); %#ok<ASGLU>
% else
%     s=udata.view.s;
%     [junk,idx]=sort(handles.alldata{d}(:,s)); %#ok<ASGLU>
% end
% 
% if udata.view.x>0
%     x=x(idx);
% end

handles.temp.xdata=x; 


handles.temp.isselected=false(size(handles.alldata{udata.view.dataset},1),1);

%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@ravesizeselection);
set(handles.fig,'WindowButtonUpFcn',@ravesizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);

guidata(src,handles);

function ravesizeselection(src,eventdata) %#ok<INUSD>
handles=guidata(src);

ai=find(handles.allgraphs==gca);

udata=get(handles.fakeax(ai),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;
xcol=udata.view.x;
ycol=udata.view.y;


%if in pointselect mode, dont allow sizing, just go straight to buttonupfcn.
maindata=findobj(gca,'type','line','marker','none');
if ~isempty(get(maindata(1),'buttondownfcn'))
    if strcmp(func2str(get(maindata(1),'buttondownfcn')),'pointselect')
        return
    end
end

finish=get(gca,'currentpoint');
starty=handles.temp.starty;
startx=handles.temp.startx;
endx=finish(1,1,1);
endy=finish(1,2,1);

pos1=min(startx,endx);
pos3=max(startx,endx)-pos1;
pos2=min(starty,endy);
pos4=max(starty,endy)-pos2;

try %#ok<TRYNC>
    set(handles.temp.selection,'position',[pos1 pos2 pos3 pos4]);
end
%determine which points are in this rectangle:

inpoints=handles.temp.xdata>pos1 & handles.temp.xdata<(pos1+pos3);
inpoints=inpoints(:);
inpoints=inpoints & handles.isvisible{udata.view.dataset}{udata.view.analysis};

if ~handles.prefs.filteredselectable
    inpoints = inpoints & ~handles.isfiltered{udata.view.dataset}{udata.view.analysis};
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}=handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

inpoints=handles.isselected{udata.view.dataset}{udata.view.analysis};

%% update graph;

%get data
if xcol>0
    x=handles.alldata{d}(:,xcol);
else
    x=(1:size(handles.alldata{d},1))';
end

y=handles.alldata{d}(:,ycol);

if isempty(x) %empty data set
    return
end

if udata.view.autoscale==1 && numel(ycol)>1
    ordersofmagnitude=10.^(round(log10(abs(mean(y)))));
    y=bsxfun(@rdivide,y,ordersofmagnitude);
elseif udata.view.autoscale==2
    minz=handles.minlimit{d}{a}(ycol);
    maxz=handles.maxlimit{d}{a}(ycol);
    y=bsxfun(@minus,y,minz);
    y=bsxfun(@rdivide,y,maxz-minz);
    
end

isselected=handles.isselected{d}{a};

%sort data:
if udata.view.s==0 || (udata.view.s==-1 && udata.view.x==0);
    %no sorting, do nothing
    idx=1:size(handles.alldata{d},1);
elseif udata.view.s==-1
    s=udata.view.x;
    [junk,idx]=sort(handles.alldata{d}(:,s)); %#ok<ASGLU>
else
    s=udata.view.s;
    [junk,idx]=sort(handles.alldata{d}(:,s)); %#ok<ASGLU>
end

if udata.view.x>0
x=x(idx);
end

y=y(idx,:);
isselected=isselected(idx);

%% Assign data to lines:
%assign ALL data before considering hidden/filtered state. THis will ensure
%that line colors dont change due to subsequent hiding/filtering.

if numel(udata.view.y)==1 && udata.view.c==0 %only drawing one line
    lineidx={true(length(x),1)};
    unz=[];
elseif numel(udata.view.y)>1 %drawing one line for each response variable, with all data points on each line.
    lineidx=true(length(x),numel(ycol));
    lineidx=mat2cell(lineidx,length(x),ones(1,numel(ycol)));
    unz=[];
else %drawing one response with data divided into lines according to udata.view.c
    constdata=handles.alldata{d}(:,udata.view.c);
    constdata=constdata(idx);
    unz=unique(constdata);
    
    %comment out the line below to draw line graphs with more than 1000 lines:
    if numel(unz)>1000;errordlg('I won''t draw a line plot that contains more than 1000 lines because presumably that''s not what you wanted me to do in the first place. If you really want to, find this line in ravecreateline.m and comment it out.');return;end
    
    lineidx=cell(1,numel(unz));
    for l=1:numel(lineidx)
        lineidx{l}=constdata==unz(l);
    end
end

V=numel(lineidx); %total number of lines being plotted


for v=1:V %v is counter for number of responses being plotted
    inline=lineidx{v};
    
    thisxsel=x(inline & isselected);
    if numel(ycol)>1;
        thisysel=y(inline & isselected,v);
    else
        thisysel=y(inline & isselected);
    end
    
    if ~isempty(thisxsel)
        set(udata.view.selectedhandles(v),'xdata',thisxsel,'ydata',thisysel,'visible','on');
    else
        set(udata.view.selectedhandles(v),'visible','off');
    end
end





handles.temp.isselected=inpoints;
guidata(src,handles);


function ravesizeselectiondone(src,eventdata) %#ok<INUSD>
handles=guidata(src);
ai=find(handles.allgraphs==gca);
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn',[]);

if isempty(ai);return;end %this can happen if handles.fig~=gcf, because for example rave has opened an optimizer progress window. In that case we don't want to do anything here.
udata=get(handles.fakeax(ai),'userdata');
%stop dragging

set(gca,'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');

isselected=false(size(handles.alldata{udata.view.dataset},1),1);
isselected(handles.temp.isselected)=true;
handles.isselected{udata.view.dataset}{udata.view.analysis}=isselected;
delete(handles.temp.selection);

%store indices of selected points.
set(handles.fakeax(ai),'userdata',udata);
guidata(src,handles);

%update other graphs:
raveupdateanalysis(src,[],'isselected',[]);

