function ravemouseoverlinedata(src,ev,ai)
%persistent handles udata

handles=guidata(src);

if handles.prefs.mouseoverdelay>0
    set(handles.mousetimer,'TimerFcn',{@processmouseover,handles,ai})
    stop(handles.mousetimer);
    start(handles.mousetimer);
else %process immediately
    processmouseover(handles.fig,[],handles,ai);    
end

function processmouseover(src,ev,handles,ai)
udata=get(handles.fakeax(ai),'userdata');

%no mouseover for a single line plot:
if numel(udata.view.y)==1 && udata.view.c==0;return;end

%show mouseovertext:

loc=get(handles.allgraphs(ai),'currentpoint');

xclick=loc(1,1);
yclick=loc(1,2);

linehandle=hittest(handles.fig);
if ~strcmp(get(linehandle,'type'),'line');return;end

xdata=get(linehandle,'xdata');
ydata=get(linehandle,'ydata');

xcol=udata.view.x;
ycol=udata.view.y;

%calculate pixel offsets:

pos=get(handles.allgraphs(ai),'position');
xlim=get(handles.allgraphs(ai),'xlim');
ylim=get(handles.allgraphs(ai),'ylim');

xpix=(xlim(2)-xlim(1))./pos(3);
ypix=(ylim(2)-ylim(1))./pos(4);

xoff=6;
yoff=6;

d=udata.view.dataset;
a=udata.view.analysis;

%show highlight marker:
set(udata.explore.mouseoverhandles(1),'xdata',xdata,'ydata',ydata,'visible','on');


%show text label:
set(udata.explore.mouseoverhandles(2),'position',[xclick yclick]+[(xoff-1)*xpix (yoff)*ypix])
set(udata.explore.mouseoverhandles(3),'position',[xclick yclick]+[(xoff+1)*xpix (yoff)*ypix])
set(udata.explore.mouseoverhandles(4),'position',[xclick yclick]+[xoff*xpix (yoff+1)*ypix])
set(udata.explore.mouseoverhandles(5),'position',[xclick yclick]+[xoff*xpix (yoff-1)*ypix])
set(udata.explore.mouseoverhandles(6),'position',[xclick yclick]+[xoff*xpix (yoff)*ypix])

%determine what string to display:
idx=udata.view.filteredhandles==linehandle;
if numel(udata.view.y)>1 %show variable name
    set(udata.explore.mouseoverhandles(2:end),'visible','on','string',handles.allnames{udata.view.dataset}{udata.view.y(idx)});
else
    val=get(linehandle,'userdata');
    switch handles.datatype{d}{udata.view.c}
        case 'string'
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string',handles.discretevalues{d}{a}{udata.view.c}{val});
        otherwise
            set(udata.explore.mouseoverhandles(2:end),'visible','on','string',num2str(val));
    end
end
    




