function lassoselectscatter(src,ev) %#ok<INUSD> %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
handles=guidata(src);
clear sizelassoscatter %clear persistent vars

handles.temp.src=src; %actual handle that was clicked
src=ancestor(src,'axes');

ai=find(handles.allgraphs==src);

udata=get(handles.fakeax(ai),'userdata');
%set(handles.fig,'windowbuttondownfcn',[]);

%check that they clicked on current graph:

%maintain manual/auto sizing:
handles.temp.axesmode=get(src,'xlimmode');
set(src,'xlimmode','manual','ylimmode','manual');

delete(handles.axeslisteners{ai});

clicked=get(src,'currentpoint');

xclick=clicked(1,1,1);
yclick=clicked(1,2,1);
handles.temp.xpoints=xclick;
handles.temp.ypoints=yclick;
%fill color:
handles.temp.selection=line(xclick, yclick,'linewidth',1,'color',[1 .5 0],...
    'parent',src,'hittest','off','buttondownfcn','','clipping','on');

%uistack(handles.temp.selection,'top');
%maindata=findobj(src,'tag','main');

handles.temp.selected=findobj(src,'tag','selected');
handles.temp.main=findobj(src,'tag','main');

handles.temp.xdata=handles.alldata{udata.view.dataset}(:,udata.view.x);
handles.temp.ydata=handles.alldata{udata.view.dataset}(:,udata.view.y);

%allow dragging
set(handles.fig,'WindowButtonMotionFcn',@sizelassoscatter);
set(handles.fig,'WindowButtonUpFcn',@sizeselectiondone);
set(handles.fig,'windowbuttondownfcn',[]);
guidata(src,handles);



function sizeselectiondone(src,eventdata) %#ok<INUSD>
clear sizelassoscatter
handles=guidata(src);
ai=find(handles.allgraphs==gca);
udata=get(handles.fakeax(ai),'userdata');
%stop dragging
set(handles.fig,'WindowButtonMotionFcn',@ravedefaultwindowbuttonmotionfcn);
set(handles.fig,'WindowButtonUpFcn','');
set(handles.allgraphs(ai),'xlimmode',handles.temp.axesmode,'ylimmode',handles.temp.axesmode)
%set(handles.temp.main,'visible','on');

%store indices of selected points.
%inpoints=get(handles.temp.selected,'userdata');
%inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,get(handles.temp.selection,'xdata'),get(handles.temp.selection,'ydata'));

xdat=get(handles.temp.selection,'xdata');
ydat=get(handles.temp.selection,'ydata');

try
    inpoints=raveinsidepoly(handles.temp.xdata,handles.temp.ydata,xdat,ydat);
catch %#ok<CTCH>
    inpoints=inpolygon(handles.temp.xdata,handles.temp.ydata,xdat,ydat);
end


[mainrows,selectedrows,filteredrows]=ravemakeplotdataseries(handles,udata);

if ~handles.prefs.filteredselectable
    inpoints=inpoints & mainrows;
else
    inpoints=inpoints & (mainrows | filteredrows);
end

if strcmp(get(handles.fig,'currentmodifier'),'shift')
    handles.isselected{udata.view.dataset}{udata.view.analysis}= handles.isselected{udata.view.dataset}{udata.view.analysis}|inpoints;
elseif strcmp(get(handles.fig,'currentmodifier'),'alt')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    lastselected(inpoints)=false;
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected;
elseif strcmp(get(handles.fig,'currentmodifier'),'control')
    lastselected=handles.isselected{udata.view.dataset}{udata.view.analysis};
    handles.isselected{udata.view.dataset}{udata.view.analysis}= lastselected & inpoints;
else
    handles.isselected{udata.view.dataset}{udata.view.analysis}=inpoints;
end

set(handles.infobar,'string',[strtrim(sprintf('%12.0f',sum(handles.isselected{udata.view.dataset}{udata.view.analysis}))) ' points selected'])

set(handles.fakeax(ai),'userdata',udata);

try %these dont work on 2007b,
    handles.axeslisteners{ai}(1)=addlistener(handles.allgraphs(ai),'XTick','PreSet',@axeschangelistener);
    handles.axeslisteners{ai}(2)=addlistener(handles.allgraphs(ai),'YTick','PreSet',@axeschangelistener);
    handles.axeslisteners{ai}(3)=addlistener(handles.allgraphs(ai),'ZTick','PreSet',@axeschangelistener);
catch
    handles.axeslisteners{ai}=[];
end

guidata(src,handles);
delete(handles.temp.selection);

%if a single point was clicked, select that point:
if length(xdat)==1 && ~strcmp(get(handles.temp.src,'type'),'axes')
    pointselectscatter(udata.view.mainhandles(1),[]);
    return
end

%update other graphs:
raveupdateanalysis(src,[],'isselected',[],udata.view.dataset,udata.view.analysis);

if handles.prefs.setxdialswhensingleselected && sum(inpoints)==1
    handles.xdials{udata.view.dataset}{udata.view.analysis}=handles.alldata{udata.view.dataset}(inpoints,:);
    guidata(src,handles);
    raveupdateanalysis(src,[],'xdials',[],udata.view.dataset,udata.view.analysis);
end
