function updatescatter3Disselected(src,ai,isselected,handles)
%updates the scatter plot with index ai to display the selection in
%isselected (logical)


if nargin<4
    handles=guidata(src);
end
udata=get(handles.fakeax(ai),'userdata');

d=udata.view.dataset;
a=udata.view.analysis;

x=handles.alldata{d}(:,udata.view.x);
y=handles.alldata{d}(:,udata.view.y);
z=handles.alldata{d}(:,udata.view.z);

if nargin<3 || isempty(isselected)
    isselected=handles.isselected{d}{a};
end


nothidden=handles.isvisible{d}{a};

selpatchhandles=udata.view.selhandles;
patchidx=udata.view.patchidx;
npatches=max(patchidx);
%selected handles

if ~udata.view.uselines
    for j=1:npatches
        selidx=patchidx==j & isselected & nothidden;
        if any(selidx)
            set(selpatchhandles(j),'xdata',x(selidx),'ydata',y(selidx),'zdata',z(selidx),'visible','on');
        else
            set(selpatchhandles(j),'visible','off');
        end
    end
else
    selidx=isselected & nothidden;
    if any(selidx)
        set(selpatchhandles,'xdata',x(selidx),'ydata',y(selidx),'zdata',z(selidx),'visible','on');
    else
        set(selpatchhandles,'visible','off');
    end
    
end
