function parallelcoordssetfilter(src,ev)
%lets user type a value for the parallel coords filters by double clicking
%them.

handles=guidata(src);

%only activate on double click.
if ~strcmp(get(handles.fig,'selectiontype'),'open');return;end
set(src,'editing','on');
oldfun=get(handles.fig,'windowbuttondownfcn');
set(0,'userdata',src);
set(handles.fig,'windowbuttondownfcn',{@changevaltextsdone,oldfun});

function changevaltextsdone(src,ev,oldfun)

handles=guidata(src);
set(handles.fig,'windowbuttondownfcn',oldfun) %do this first in case of errors later.

src=get(0,'userdata');

thisax=get(src,'parent');
ai=find(handles.fakeax==thisax);
udata=get(handles.fakeax(ai),'userdata');

%determine if this is a minfilter or a max filter:
maxtexts=findobj(thisax,'tag','maxtexter');
mintexts=findobj(thisax,'tag','mintexter');

if ismember(src,maxtexts)
    ismax=true;
else
    ismax=false;
end

newvalue=str2double(get(src,'string'));

minz=udata.view.varmins;
rangez=udata.view.varranges;
maxz=minz+rangez;

maxfilterz=udata.view.maxfiltercoord.*rangez+minz;
minfilterz=udata.view.minfiltercoord.*rangez+minz;

if ismax
    oldvalue=maxfilterz(udata.view.x(src==maxtexts));
    if isnan(newvalue);newvalue=oldvalue;end
    if newvalue>maxz(udata.view.x(src==maxtexts)); newvalue=maxz(udata.view.x(src==maxtexts));end
    if newvalue<minz(udata.view.x(src==maxtexts)); newvalue=minz(udata.view.x(src==maxtexts));end
    if newvalue<minfilterz(udata.view.x(src==maxtexts)); newvalue = minfilterz(udata.view.x(src==maxtexts));end
    set(src,'string',['' raveformatnumber(newvalue)]);
    udata.view.highfilter(udata.view.x(src==maxtexts))=newvalue;
    
    %convert newvalue to 0-1:
    newvalue=(newvalue-minz(udata.view.x(src==maxtexts)))./rangez(udata.view.x(src==maxtexts));
    pos=get(src,'position');
    pos(2)=newvalue;
    set(src,'position',pos);
    
    idx=get(src,'userdata');
    set(udata.view.maxdraggers(idx,:),'ydata',newvalue);
    udata.view.maxfiltercoord(udata.view.x(src==maxtexts))=newvalue;    

else
    oldvalue=minfilterz(udata.view.x(src==mintexts));
    if isnan(newvalue);newvalue=oldvalue;end
    if newvalue>maxz(udata.view.x(src==mintexts)); newvalue=maxz(udata.view.x(src==mintexts));end
    if newvalue<minz(udata.view.x(src==mintexts)); newvalue=minz(udata.view.x(src==mintexts));end
    if newvalue>maxfilterz(udata.view.x(src==mintexts)); newvalue = minfilterz(udata.view.x(src==mintexts));end
    set(src,'string',['',raveformatnumber(newvalue)]);
    udata.view.lowfilter(udata.view.x(src==mintexts))=newvalue;
    
    %convert newvalue to 0-1:
    newvalue=(newvalue-minz(udata.view.x(src==mintexts)))./rangez(udata.view.x(src==mintexts));
    pos=get(src,'position');
    pos(2)=newvalue;
    set(src,'position',pos);
    
    idx=get(src,'userdata');
    set(udata.view.mindraggers(idx,:),'ydata',newvalue);
    udata.view.minfiltercoord(udata.view.x(src==mintexts))=newvalue;   
end

set(handles.fakeax(ai),'userdata',udata);

%apply filter globally:
handles.minfilter{udata.view.dataset}{udata.view.analysis}=udata.view.lowfilter;
handles.maxfilter{udata.view.dataset}{udata.view.analysis}=udata.view.highfilter;
guidata(handles.fig,handles);
parallelcoordsapplyfilter(src,[],ai,handles);
raveupdateanalysis(src,[],'isfiltered',ai,udata.view.dataset,udata.view.analysis)

%return
% 
% %do filtering:
% allkidz=udata.view.mainhandles;
% %selected=sort(findobj(handles.allgraphs(ai),'tag','selected'));
% allydata=cell2mat(get(allkidz,'ydata'));
% 
% maxoutlier=bsxfun(@gt,allydata,udata.view.maxfiltercoord(udata.view.x));
% minoutlier=bsxfun(@lt,allydata,udata.view.minfiltercoord(udata.view.x));
% 
% outliers=minoutlier | maxoutlier;
% outliers=any(outliers,2);
% 
% %dim infeasible rows:
% set(allkidz(outliers),'visible','off');
% set(allkidz(~outliers),'visible','on');
% set(udata.view.hiddenhandles(outliers),'visible','on');
% set(udata.view.hiddenhandles(~outliers),'visible','off');
% 
% udata.view.filtered=outliers;
% set(handles.fakeax(ai),'userdata',udata);
% 
% 
% 
% 
