function raveupdateparallelcoordsdatachanged(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

handles=guidata(src);

udata=get(handles.fakeax(handles.activeindex),'userdata');

xcol=udata.view.x;
%ycols=udata.view.y;
ccol=udata.view.c;
% pscales=udata.view.pscale;
% gscales=udata.view.gscale;
a=udata.view.analysis;
d=udata.view.dataset;

%get data
x=handles.alldata{d}(:,xcol);
%normalize xdata:
data1=bsxfun(@minus,x,handles.minlimit{d}{a}(xcol));
data2=bsxfun(@rdivide,data1,(handles.maxlimit{d}{a}(xcol)-handles.minlimit{d}{a}(xcol)));
data2(isnan(data2))=.5;
x=data2;

%maintain hidden points:
nothidden=handles.isvisible{udata.view.dataset}{udata.view.analysis};

%filter based on max rows
if udata.view.usemaxlines
   index=udata.view.maxlineindex;
else    
    index=1:size(x,1);    
end

nothidden=nothidden(index);
x=x(index,:);

%% get constantvalues:
% if constcol is blank, use a column of ones of same length as xdata.
% Otherwise use the actual data from the constcol column.


%append a column of ones on the end for when constcol="none selected"...
%might need to move this line somewhere else in code.


allcolorz=get(handles.fig,'colormap');

if ccol~=0
    c=handles.alldata{d}(index,ccol);
    %normalize cdata to desired colormap:
    c=(c-min(c))/(max(c)-min(c))*127+128*(udata.format.lcmap-1)+1;   
    %cdata=[linterp(1:size(allcolorz,1),allcolorz(:,1),c)' linterp(1:size(allcolorz,1),allcolorz(:,2),c)' linterp(1:size(allcolorz,1),allcolorz(:,3),c)'];   
    c(isnan(c))=128*(udata.format.lcmap-1)+1;

    cdata=allcolorz(floor(c),:);
    
    
else %USE ROW COLORS

    c=1920+(handles.rowcolors{udata.view.dataset}{udata.view.analysis}(index))'; %non-noisy colors cdata=0.5     
    cdata=allcolorz(c,:);
    
    if udata.format.ncolor %do noisy colors
        noise=0.3; %noise multiplier
        cdata=cdata+(rand(size(cdata))-.5)*noise; 
        cdata(cdata<0)=0;
        cdata(cdata>1)=1;
           
    end 
end

%if any x is outside 0-1, need to rescale data, and update ranges:

%remove hidden rows:
x=x(nothidden,:);
cdata=cdata(nothidden,:);

%% make data:
if ccol~=0
    for r=1:size(x,1);
        set(udata.view.hiddenhandles(r),'ydata',x(r,:),'color',cdata(r,:),'userdata',cdata(r,:));
        set(udata.view.mainhandles(r),'ydata',x(r,:),'color',cdata(r,:),'userdata',cdata(r,:));
        set(udata.view.selectedhandles(r),'ydata',x(r,:),'color',cdata(r,:),'userdata',cdata(r,:));
    end
else
    for r=1:size(x,1);
        set(udata.view.hiddenhandles(r),'ydata',x(r,:));
        set(udata.view.mainhandles(r),'ydata',x(r,:));
        set(udata.view.selectedhandles(r),'ydata',x(r,:));
    end
end

parallelcoordsapplyfilter(src,[]);




