function formattabtablesinglepoint(src,eventdata) %#ok<INUSD>
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%RAVE: creates uicontrols on the view tab for line graphs.

handles=guidata(src);

%move front tabs to front if necessary
% if handles.fronttabsfront==0 %swap fronttabs and backtabs
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
set(handles.fronttabaxes,'xcolor',handles.colors.tabbg,'ycolor',handles.colors.tabbg);
set(handles.backtabaxes,'xcolor',handles.colors.frame,'ycolor',handles.colors.frame);
% end
% handles.fronttabsfront=1;

[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,3,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)

set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% clear existing tab
%delete(handles.tabobjects)

%% get input info from graph:
udata=get(handles.fakeax(handles.activeindex),'userdata');
d=udata.view.dataset;
a=udata.view.analysis;

%% text headers
tabletext=text(.15-.10317,.97,'Table','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
appearancetext=text(.15-.10317,.4,'Appearance','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

%%

titletext=uicontrol('position',[origin(1)+25 origin(2)+576 180 20],...
    'style','text','string','Title:','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
titlebox=uicontrol('position',[origin(1)+65 origin(2)+578 180 20],...
    'style','edit','string',udata.format.title,'backgroundcolor',[1 1 1],...
    'fontname','arial','fontsize',10,'horizontalalignment','left','callback',@title_callback);

names={'Variable','Value'};
values=[udata.view.headerwidth udata.view.colwidths];

for v=1:numel(values)
    valtext{v}=strtrim(sprintf('%6.0f',values(v)));
end

dat = [names' valtext'];
cnames = {'Column Name','Width'};

jtable=javax.swing.JTable(dat,cnames); %initialize a table
j=javax.swing.JScrollPane(jtable); %initialize a scrollpane that contains the table
jtable.setFillsViewportHeight(true); %make table fill the scrollpane
[jscrollpane mtable]=javacomponent(j,[origin(1)+25 origin(2)+350 220 188],handles.fig);

%% Setting column widths:
jtable.getTableHeader().setReorderingAllowed(false) %turn off draggable columns
jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF) %turn off auto resizing
colwidths=[151 50];

for c=1:2 %set the widths:
    jtable.getColumnModel().getColumn(c-1).setPreferredWidth(colwidths(c))
end
%handles.tabflexgrid=jtable;
set(mtable,'tag','mtable');


applybutton=uicontrol('position',[origin(1)+30 origin(2)+320 215 24],...
    'style','pushbutton','string','Apply Changes',...
    'horizontalalignment','left','callback',@applybutton_callback);

%% GRAPH UICONTROLS
headtext=uicontrol('position',[origin(1)+57+30 origin(2)+189+25 140 20],...
    'style','text','string','Row/Col Header','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
rheadblob=uicontrol('position',[origin(1)+30 origin(2)+193+25 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.rowheadercolor,...
    'callback',@rheadblob_callback);
cheadblob=uicontrol('position',[origin(1)+30+30 origin(2)+193+25 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.colheadercolor,...
    'callback',@cheadblob_callback);

texttext=uicontrol('position',[origin(1)+57 origin(2)+189 180 20],...
    'style','text','string','Text','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
textblob=uicontrol('position',[origin(1)+30 origin(2)+193 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.textcolor,...
    'callback',@textblob_callback);

bgtext=uicontrol('position',[origin(1)+57 origin(2)+164 180 20],...
    'style','text','string','Background','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
bgblob=uicontrol('position',[origin(1)+30 origin(2)+168 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.unselectedcolor,...
    'callback',@bgblob_callback);

gridtext=uicontrol('position',[origin(1)+57 origin(2)+89 180 20],...
    'style','text','string','Grid Lines','backgroundcolor',handles.colors.tabbg,...
    'fontname','arial','fontsize',10,'horizontalalignment','left','fontweight','bold');
gridblob=uicontrol('position',[origin(1)+30 origin(2)+93 20 20],...
    'style','pushbutton','string','','backgroundcolor',udata.format.gridlinecolor,...
    'callback',@gridblob_callback);


%% font stuff
fontlist=listfonts;

sizelist={'6';'7';'8';'9';'10';'11';'12';'14';'16';'18';'20';'22';'24';'28';'32';'36';'42';'48'};

fontvalue=find(strcmpi(fontlist,udata.format.fontname),1);
if isempty(fontvalue)
    fontvalue=1;
end

sizevalue=find(strcmp(sizelist,num2str(udata.format.fontsize)),1);
if isempty(sizevalue)
    sizevalue=1;
end

if udata.format.fontstyle==3
    boldvalue=1;
    italicvalue=1;
elseif udata.format.fontstyle==1
    boldvalue=1;
    italicvalue=0;
elseif udata.format.fontstyle==2;
    italicvalue=1;
    boldvalue=0;
else
    boldvalue=0;
    italicvalue=0;
end

%uicontrols
fontpicker=uicontrol('position',[origin(1)+25 origin(2)+44 219 22],'style','popupmenu',...
    'string',fontlist,'parent',handles.fig,'max',10,'value',fontvalue,...
    'backgroundcolor',[1 1 1],'tag','fontpicker','callback',@fontpicker_callback);

boldbutton=uicontrol('position',[origin(1)+25 origin(2)+10 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('bold.bmp'),...
    'tag','boldbutton','callback',@fontpicker_callback,'value',boldvalue);

italicbutton=uicontrol('position',[origin(1)+55 origin(2)+10 24 24],'style','togglebutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('italic.bmp'),...
    'tag','italicbutton','callback',@fontpicker_callback,'value',italicvalue);

fontdownbutton=uicontrol('position',[origin(1)+145 origin(2)+10 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontdown.bmp'),...
    'callback',@fontdown_callback);

fontsizer=uicontrol('position',[origin(1)+176 origin(2)+10 40 22],'style','popupmenu',...
    'string',sizelist,...
    'parent',handles.fig,'max',1,'value',sizevalue,...
    'backgroundcolor',[1 1 1],'tag','fontsizer','callback',@fontpicker_callback);

fontupbutton=uicontrol('position',[origin(1)+220 origin(2)+10 24 24],'style','pushbutton',...
    'string','','callback','','backgroundcolor',[0 0 0],...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'cdata',imread('fontup.bmp'),...
    'callback',@fontup_callback);



%% group items and finish up
handles.tabobjects=[tabletext appearancetext titletext titlebox mtable applybutton texttext textblob ...
    bgtext bgblob gridtext gridblob fontpicker boldbutton italicbutton ...
    fontdownbutton fontsizer fontupbutton headtext rheadblob cheadblob];

handles.activetab='format';

guidata(src,handles);



function title_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
udata.format.title=get(src,'string');
titel=get(udata.format.titleaxes,'children');
set(titel,'string',get(src,'string'));
set(handles.fakeax(handles.activeindex),'userdata',udata);
raveresizetable(handles.fig,[],handles.activeindex);

function applybutton_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

mtable=findobj(handles.tabobjects,'type','hgjavacomponent');
jscroll=get(mtable,'javapeer');
jtable=jscroll.getViewport.getComponent(0);
name=jtable.getValueAt(1,0);
headwidth=str2double(jtable.getValueAt(0,1));
width=str2double(jtable.getValueAt(1,1));

if isnan(width);width=90;end
if width>1000;width=1000;end
if isnan(headwidth);headwidth=90;end
if headwidth>1000;headwidth=1000;end

udata.view.colnames={name};
udata.view.colwidths=width;
udata.view.headerwidth=headwidth;



set(handles.fakeax(handles.activeindex),'userdata',udata);
ravecreatetablesinglepoint(handles.fig,[]);

function textblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.textcolor,'Choose a cell text color');
set(src,'backgroundcolor',newcolor);
udata.format.textcolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(src,handles);

ravecreatetablesinglepoint(handles.fig,[]);


function bgblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.unselectedcolor,'Choose a cell background color');
set(src,'backgroundcolor',newcolor);
udata.format.unselectedcolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(src,handles);

ravecreatetablesinglepoint(handles.fig,[]);



function gridblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.gridlinecolor,'Choose a grid line color');
set(src,'backgroundcolor',newcolor);
udata.format.gridlinecolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(src,handles);

ravecreatetablesinglepoint(handles.fig,[]);


function rheadblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.rowheadercolor,'Choose a row header color');
set(src,'backgroundcolor',newcolor);
udata.format.rowheadercolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(src,handles);
ravecreatetablesinglepoint(handles.fig,[]);

function cheadblob_callback(src,ev)
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');
newcolor=ravecolorchooser(handles.fig,udata.format.colheadercolor,'Choose a column header color');
set(src,'backgroundcolor',newcolor);
udata.format.colheadercolor=newcolor;
set(handles.fakeax(handles.activeindex),'userdata',udata);
guidata(src,handles);
ravecreatetablesinglepoint(handles.fig,[]);

