function ravecreatetablestatistics(src,ev)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2010 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
handles=guidata(src);
udata=get(handles.fakeax(handles.activeindex),'userdata');

data=udata.view.data;

numfun=@(x) sprintf('%-12.5g',x);
%convert data into a cell array of strings:
%(all data is numerical for statistics table... no need to check for string
%columns)
if ~isempty(data)
    data=num2cell(data);
    data=cellfun(numfun,data,'uniformoutput',0);
end

rownames=udata.view.rownames;
rowheight=udata.view.rowheight;
colnames=udata.view.colnames(udata.view.y);
colwidths=udata.view.colwidths(udata.view.y);
headerwidth=udata.view.headerwidth;
headerheight=udata.view.headerheight;
rowcolors=udata.format.unselectedcolor;
rhcolors=udata.format.rowheadercolor;

ravemaketablecore(handles.fig,[],handles.activeindex,data,rownames,rowheight,colnames,colwidths,headerwidth,headerheight,rowcolors,rhcolors);

raveresizetable(handles.fig,[],handles.activeindex);
%fix scrolling
verttablescroll(handles.activegraph,[],0)


