

if isempty(settings.termmatrix);
   errordlg('You must choose the terms in this model by clicking "Choose Terms" before you can add it to the queue.','Invalid Settings')
   return
end

if numel(settings.termsx)~=numel(settings.inputs) || ~all(settings.termsx==settings.inputs)
    errordlg('The selection in the "As functions of" box has changed since you selected the terms to include in this model. You must either re-select the terms, or restore the selection in the "As functions of" box to its previous value.','Invalid Settings');
    return
end

tformstrings=get(ui(7),'string');
settings.transformby=tformstrings{get(ui(7),'value')};
settings.maxeffects=str2double(get(ui(10),'string'));
settings.maxtratio=str2double(get(ui(12),'string'));
settings.includeintercept=get(ui(14),'value');


if settings.includeintercept;
    settings.termmatrix=[zeros(1,size(settings.termmatrix,2));settings.termmatrix];
end


if isnan(settings.maxeffects) || settings.maxeffects<1
    errordlg('You must enter a positive interger or "inf" in the "Save only the largest ___ effects" box.','Invalid Settings');
    return    
end

if isnan(settings.maxtratio) || settings.maxtratio<=0 || settings.maxtratio>1
    errordlg('You must enter a positive numerical value that is less or equal to 1 in the "Exclude effects with t-ratio larger than ___" box.','Invalid Settings');
    return    
end

settings.optimizeformatlab=get(ui(13),'value');

%use settings.notes to display additional information in the table based on
%the above settings:

maxorder=max(sum(settings.termmatrix,2));
nterms=size(settings.termmatrix,1);

settings.notes=['Order = ',num2str(maxorder),'; ',num2str(nterms),' terms'];




