function ui=makemodeluicontrolsffneuralnet(src,ev)  

ui(1)=uicontrol('style','text','Position',[570 600+60+8-20 300 20],'string','Topology:','fontsize',10,'fontweight','bold',...
    'hor','left','backgroundcolor',[1 1 1],'userdata','methodcontrol');

ui(2)=uicontrol('style','text','Position',[590 580+60+8-17 300 18],'string','Hidden nodes:','fontsize',10,'fontweight','normal',...
    'hor','left','backgroundcolor',[1 1 1],'userdata','methodcontrol');

ui(3)=uicontrol('style','edit','Position',[680 580+60+8-17 30 18],'string','5',...
    'hor','center','backgroundcolor',[1 1 1],'tag','degreeedit','userdata','methodcontrol');

ui(4)=uicontrol('style','text','Position',[590 554+60+8-17 300 20],'string','Transfer fcn:','fontsize',10,'fontweight','normal',...
    'hor','left','backgroundcolor',[1 1 1],'value',1,'tag','includecrosscheck','userdata','methodcontrol');

ui(5)=uicontrol('style','popup','position',[670 554+60+8-17 80 20],'string',{'logsig';'tansig'},...
    'backgroundcolor',[1 1 1],'userdata','methodcontrol');

ui(6)=uicontrol('style','text','Position',[570 530+60+8-17 300 20],'string','Training algorithm:','fontsize',10,'fontweight','bold',...
    'hor','left','backgroundcolor',[1 1 1],'userdata','methodcontrol');

v=ver('nnet');
if isempty(v)
    errordlg('This model type requires the MATLAB neural network toolbox, which does not appear to be installed. This toolbox must be purchased from The Mathworks.','Toolbox Required')
end

    str={'Batch training with weight and bias learning rules (trainb)',...
        'BFGS quasi-Newton backpropagation (trainbfg)',...
        'Bayesian regularization (trainbr)',...
        'Batch unsupervised weight/bias training (trainbuwb)',...
        'Cyclical order increment update (trainc)',...
        'Powell-Beale conjugate gradient backpropagation (traincgb)',...
        'Fletcher-Powell conjugate gradient backpropagation (traincgf)',...
        'Polak-Ribiere conjugate gradient backpropagation (traincgp)',...
        'Gradient descent backpropgation (traingd)',...
        'Gradient descent with adaptive learning rule backpropagation (traingda)',...
        'Gradient descent with momenentum backpropagation (traingdm)',...
        'Gradient descent with momentum and adaptive learning rule backpropagation (traingdx)',...
        'Levenberg-Marquardt backpropagation (trainlm)',...
        'One step secant backpropagation (trainoss)',...
        'Random order incremental training with learning functions (trainr)',...
        'Resilient backpropagation (trainrp)',...
        'Sequential order incremental training with learning functions (trains)',...
        'Scaled conjugate gradient backpropagation (trainscg)'};
       
    ui(7)=uicontrol('style','popup','position',[590 512+60+8-17 230 20],'string',str,'value',13,...
        'backgroundcolor',[1 1 1],'userdata','methodcontrol','callback',@setffneuralnetalgorithm);
    
    %make default table rows:
    s=updateffneuralnetsettingstable('trainlm');
    
    %make settings table:
    dat = [s(:,1),s(:,3)];
    cnames = {'Parameter','Value'};
    
    jtable=javax.swing.JTable(dat,cnames); %initialize a table
    j=javax.swing.JScrollPane(jtable); %initialize a scrollpane that contains the table
    jtable.setFillsViewportHeight(true); %make table fill the scrollpane
    [jscrollpane mtable]=javacomponent(j,[590 430-17 230 145],gcf);
    
    jscrollpane.setHorizontalScrollBarPolicy(javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    
    %% Setting column widths:
    jtable.getTableHeader().setReorderingAllowed(false) %turn off draggable columns
    
    dims=jtable.getTableHeader().getPreferredSize;
    dims.setSize(dims.getWidth,20)
    jtable.getTableHeader().setPreferredSize(dims);
    jtable.getTableHeader().setSize(dims);
    
    jtable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF)%turn off auto resizing
    colwidths=[128 100]; %some column widths
    
    for c=1:2 %set the widths:
        jtable.getColumnModel().getColumn(c-1).setPreferredWidth(colwidths(c))
    end
    
    
    set(mtable,'tag','mtable');

    ui(8)= mtable;
 
    ui(9)=uicontrol('style','checkbox','Position',[590 418-23+12-17 300 20],'string','Regularization','fontsize',10,'fontweight','normal',...
        'hor','left','backgroundcolor',[1 1 1],'value',0,'tag','includecrosscheck','userdata','methodcontrol');
     
    ui(10)=uicontrol('style','edit','Position',[700 418-23+12-17 30 18],'string','0.5','fontsize',8,'fontweight','normal',...
        'hor','center','backgroundcolor',[1 1 1],'userdata','methodcontrol');

   str={'Conscience bias learning function',...
       'Gradient descent weight/bias learning function',...
       'Gradient descent with momentum weight/bias learning function',...
       'Hebbb weight learning function',...
       'Hebb with decay weight learning rule',...
       'Instar weight learning function',...
       'Kohonen weight learning function',...
       'LVQ1 weight learning function',...
       'LVQ2 weight learning function',...
       'Outstar weight learning functino',...
       'Perceptron weight and bias learning function',...
       'Normalized perceptron weight and bias learning function',...
       'Self-organizaing map weight learning function',...
       'Batch self-organizing map weight learning function',...
       'Widrow-Hoff weight and bias learning rule'};
    
    ui(11)=uicontrol('style','text','Position',[570 370+15-17 300 20],'string','Learning algorithm:','fontsize',10,'fontweight','bold',...
        'hor','left','backgroundcolor',[1 1 1],'userdata','methodcontrol');
    
    ui(12)=uicontrol('style','popup','position',[590 353+13-17 230 20],'string',str,'value',2,...
        'backgroundcolor',[1 1 1],'userdata','methodcontrol');
    
    ui(13)=makehelpblob(gcf,822,548+25+8-17,'*trainlm',[1 1 1],'Display help on selected algorithm');

    ui(14)=uicontrol('style','checkbox','Position',[563 670 300 16],'string','Fit a separate network for each variable','fontsize',8,'fontweight','normal',...
        'hor','left','backgroundcolor',[1 1 1],'value',0,'tag','includecrosscheck','userdata','methodcontrol');
    
   
    