function [displaynames,settingnames,settingvalues,isastring]=raveparseoptimizersettingsdefault(src,ev,thismethod)
%reads the optimizersettingsTHISMETHOD.m file and returns its results in
%cell arrays

handles=guidata(src);

%do selected method:
allsettings=handles.optimizerinfo.(thismethod);

%remove standard fields:
allsettings=rmfield(allsettings,{'longname','class'});

displaynames={};
settingnames={};
settingvalues={};
isastring=false(0);

settingnames=fieldnames(allsettings);
for s=numel(settingnames):-1:1;
    thisvalue=handles.optimizerinfo.(thismethod).(settingnames{s});
    if ~iscell(thisvalue);continue;end
    if numel(thisvalue)~=2;continue;end
    if ~ischar(thisvalue{1});continue;end
    
    displaynames{s}=thisvalue{1};
    settingvalues{s}=thisvalue{2};
    
    if ischar(thisvalue{2})
        isastring(s)=true;
    else
        isastring(s)=false;
    end
    
end

%convert numerical setting values to text:
for g=1:numel(settingvalues)
    if ~isastring(g)
        settingvalues{g}=num2str(settingvalues{g});
    end
end
