function outrows=ravecalculatefilteredstate(src,ev,d,a)
%returns a logical list of which rows in dataset d, analysis a, are
%currently filtered. 

handles=guidata(src);

[nrows,nvars]=size(handles.alldata{d});

inrows=false(nrows,nvars);


for x=1:nvars;
    switch handles.datatype{d}{x}
        case 'continuous'
            inrows(handles.alldata{d}(:,x)+eps(max(handles.alldata{d}(:,x)))>=handles.minfilter{d}{a}(x)-eps(handles.minfilter{d}{a}(x)) & handles.alldata{d}(:,x)-eps(max(handles.alldata{d}(:,x)))<=handles.maxfilter{d}{a}(x)+eps(handles.maxfilter{d}{a}(x)),x)=true;
        case 'string'
            filt=find(handles.discretefilter{d}{a}{x});
            inrows(ismembc(handles.alldata{d}(:,x),filt),x)=true;
        otherwise
            inrows(:,x)=true; %dont filter on unsupported variable types
    end
    
    %do not exclude NaN data. If you would like NaN data to show up as
    %being filtered, set right hand side to false below:
    inrows(isnan(handles.alldata{d}(:,x)),x)=true;
    
end

outrows=~all(inrows,2);


