function ravecheckforupdates

load raveprefs
if ~raveprefs.checkforupdates;return;end

try
verstring=urlread('http://www.rave.gatech.edu/currentversion');
catch %#ok<CTCH>
    return
end

sep=find(verstring==';');
nv=str2double(verstring(1:sep-1));
cv=raveprefs.currentversion;

if nv<=cv;return;end

figpos=raveprefs.preferredposition;
pos=[figpos(1)+(figpos(3)-300)/2, figpos(2)+(figpos(4)-200)/2 320 140];
f=figure('units','pixels','position',pos,'name','Rave - New Version Available','numbertitle','off','menubar','none','toolbar','none',...
    'closerequestfcn',{@closewindow,nv},'resize','off','color',raveprefs.colors.frame);

uicontrol('style','text','position',[20 60 260 70],'string',...
    {['Rave version ',verstring(sep+1:end),' is now available.'];'Download it at http://www.rave.gatech.edu'},'hor','left',...
    'backgroundcolor',get(f,'color'),'fontsize',10)

uicontrol('style','checkbox','position',[20 55 380 30],'string',...
    'Do not remind me again about this update','hor','left',...
    'backgroundcolor',get(f,'color'),'fontsize',10,'tag','check')

uicontrol('style','pushbutton','string','Ok','position',[110 20 100 24],'callback',@donebutton)



function donebutton(src,ev)
close(gcf);

function closewindow(src,ev,nv)
check=findobj(gcf,'tag','check');

if get(check,'value')
    prefpath=which('raveprefs.mat');
    load raveprefs
    raveprefs.currentversion=nv;
    save(prefpath,'raveprefs');
end

delete(gcf);


