function ravedeletevars(src,ev,d,deletethese)
%deletes variable(s) with indices "deletethese" from data set d.
handles=guidata(src);


if islogical(deletethese);deletethese=find(deletethese);end

nvars=size(handles.alldata{d},2);
keep=setdiff(1:nvars,deletethese);

handles=guidata(src);

backupdata=getappdata(handles.fig,'backupdata');
backupdata{d}=backupdata{d}(:,keep);
setappdata(handles.fig,'backupdata',backupdata);


handles.alldata{d}=handles.alldata{d}(:,keep);

handles.alltext{d}=handles.alltext{d}(:,keep);
handles.allnames{d}=handles.allnames{d}(keep);
handles.variablecolors{d}=handles.variablecolors{d}(keep,:);
handles.isresponse{d}=handles.isresponse{d}(keep);
handles.allunits{d}=handles.allunits{d}(keep);
handles.isvalid{d}=handles.isvalid{d}(:,keep);
handles.isincluded{d}=handles.isincluded{d}(keep);
handles.isdecided{d}=handles.isdecided{d}(keep);
handles.isnoise{d}=handles.isnoise{d}(keep);
handles.isconstant{d}=handles.isconstant{d}(keep);
handles.isfunction{d}=handles.isfunction{d}(keep);
handles.funclass{d}=handles.funclass{d}(keep);
handles.funnames{d}=handles.funnames{d}(keep);
handles.funvars{d}=handles.funvars{d}(keep);
handles.nargout{d}=handles.nargout{d}(keep);
handles.datatype{d}=handles.datatype{d}(keep);
handles.targetvalues{d}=handles.targetvalues{d}(keep);
handles.preferences{d}=handles.preferences{d}(keep);
handles.isobjective{d}=handles.isobjective{d}(keep);
handles.rankingcolumn{d}=handles.rankingcolumn{d}; %check if rankingcolumn is being deleted. If so, change it. 
handles.maintable.colwidths{d}=handles.maintable.colwidths{d}(keep);


%analysis variables:
for a=1:numel(handles.analysisnames);
    handles.xdials{d}{a}=handles.xdials{d}{a}(keep);
    handles.minlimit{d}{a}=handles.minlimit{d}{a}(keep);
    handles.maxlimit{d}{a}=handles.maxlimit{d}{a}(keep);
    handles.discretevalues{d}{a}=handles.discretevalues{d}{a}(keep);
    handles.ineqconstraints{d}{a}=handles.ineqconstraints{d}{a};
    handles.distname{d}{a}=handles.distname{d}{a}(keep);
    handles.distparams{d}{a}=handles.distparams{d}{a}(keep);   
    
    %remove constraints that use these variables:
    keepc=true(1,numel(handles.constrainthandles{d}{a}));
    for c=1:numel(keepc)
        if any(ismember(deletethese,handles.constraintvars{d}{a}{c}))
            keepc(c)=false;
        end 
    end
    keepc=find(keepc);
    handles.constrainthandles{d}{a}=handles.constrainthandles{d}{a}(keepc);
    handles.constrainttext{d}{a}=handles.constrainttext{d}{a}(keepc);
    handles.constrainttype{d}{a}=handles.constrainttype{d}{a}(keepc);
    handles.constraintvalues{d}{a}=handles.constraintvalues{d}{a}(keepc);
    handles.constraintadders{d}{a}=handles.constraintadders{d}{a}(keepc);
    handles.constraintscalers{d}{a}=handles.constraintscalers{d}{a}(keepc);
    handles.constraintvars{d}{a}=handles.constraintvars{d}{a}(keepc); 
    handles.constraintcolors{d}{a}=handles.constraintcolors{d}{a}(keepc);

end



guidata(handles.fig,handles);