function ravehidetabs(src,eventdata) %#ok<INUSD> % %hide / show tabs.
handles=guidata(src);

if isempty(handles.activeindex);return;end

if isempty(handles.projectname)
    set(handles.fig,'name','Rave <<Hit ESC to exit full-screen mode>>')
else
    set(handles.fig,'name',handles.projectname)
end

set(handles.stopbutton,'visible','off')

%make manage tab active since it is known to have no issues
managetab(src,[])

%turn off graph hittests so no new tabs appear:
set(handles.allblockers(ishandle(handles.allblockers)),'hittest','off','visible','off');

%update handles
handles=guidata(src);

hideobjs=findobj([handles.explorer,handles.tabaxes,handles.fronttabaxes,...
    handles.explorertitle,handles.titleaxes,handles.backtabaxes,handles.bgtabaxes handles.controltitle]);

set(hideobjs,'visible','off')
set(handles.tabobjects,'visible','off')

%reduce leftmarginposition to 1 pixel
leftpos=get(handles.leftmargin,'position');
leftpos(3)=1;
set(handles.leftmargin,'position',leftpos);
toppos=get(handles.topmargin,'position');
set(handles.topmargin,'position',toppos+[0 35 0 0])
%update workspaceposition
rightpos=get(handles.rightmargin,'position');
toppos=get(handles.topmargin,'position');
botpos=get(handles.bottommargin,'position');
handles.workspacedims=[rightpos(1)-leftpos(1)-leftpos(3),toppos(2)-botpos(2)-botpos(4)];
handles.workspacepos=[leftpos(1)+leftpos(3) botpos(2)+botpos(4) handles.workspacedims(1) handles.workspacedims(2)];

%turn off grid:
set(handles.lgrid,'visible','off')
set(handles.mgrid,'visible','off')
set(handles.sgrid,'visible','off')

set(handles.grabbers{handles.activeindex},'visible','off')

%stretch out the scroll bar:
cvpos=get(handles.currentview,'position');

cvpos(3)=min(handles.workspacepos(3),handles.prefs.wswidth);
cvpos(4)=min(handles.workspacepos(4),handles.prefs.wsheight);
set(handles.currentview,'position',cvpos);

set(handles.hscroll,'position',[1 1 handles.width-17 16],...
    'sliderstep',[.02 cvpos(3)/((handles.prefs.gridsize*handles.wscols)-cvpos(3))],...
    'min',cvpos(3)/2,'max',handles.prefs.gridsize*handles.wscols-cvpos(3)/2,'value',cvpos(3)/2);
set(handles.vscroll,'position',[handles.width-16 18 16 handles.height-54+35],...
    'min',cvpos(4)/2,'max',handles.prefs.gridsize*handles.wsrows-cvpos(4)/2,...
    'sliderstep',[.05 cvpos(4)/((handles.prefs.gridsize*handles.wsrows)-cvpos(4))],...
    'value',handles.prefs.gridsize*handles.wsrows-cvpos(4)/2)

%update handles
handles.tabsvisible=0;
guidata(src,handles);

%move view to new origin
if ~handles.tablemode
    ravemoveview(handles.fig,[],[0 handles.prefs.wsheight-1+35]);
else
    ravedisplaymaintable(handles.fig,[]);
end

set(handles.tablemodebutton,'visible','off');
set(handles.showgridbutton,'visible','off');
set(handles.openglbutton,'visible','off');
set(handles.zoombutton,'visible','off');
set(handles.hideshowbutton,'visible','off');
set(handles.newbutton,'visible','off');
set(handles.infobar,'visible','off');
set(handles.fig,'windowkeypressfcn',@raveshowtabs);

%set(handles.fig,'currentobject',handles.fig);

%move page controls:
switch upper(handles.prefs.pagecontrollocation)
    case 'SE'
        set(handles.pageedit,'position',[handles.width+285-370 25 40 20]);
        set(handles.pagecontrols.left,'position',[handles.width+268-370 20 17 27]);
        set(handles.pagecontrols.right,'position',[handles.width+325-370 20 17 27]);
end

lbutton=imread('leftbuttonup.png','backgroundcolor',handles.colors.wsbg);
rbutton=imread('rightbuttonup.png','backgroundcolor',handles.colors.wsbg);
set(handles.pagecontrols.left,'cdata',lbutton);
set(handles.pagecontrols.right,'cdata',rbutton);
set(handles.pageedit,'backgroundcolor',handles.colors.wsbg)

