function handles=raveinitializehandles(handles)
%makes the initial handles structured used by a new Rave session. 

handles.alldata=cell(0);
handles.datasetnames=cell(0);
handles.datasetfiles=cell(0);
handles.datasettypes=cell(0);
handles.datasetlinks=cell(0);
handles.datasetlinkinfo=cell(0);
handles.analysisnames={'Default Analysis'};
handles.allnames=cell(0);
handles.isvalid=cell(0);
handles.isresponse=cell(0);
handles.nargout=cell(0);
handles.allunits=cell(0);
handles.isincluded=cell(0);
handles.isdecided=cell(0);
handles.alltext=cell(0);
handles.discretevalues=cell(0);
%analysis stuff:
handles.targetvalues=cell(0);
handles.xdials=cell(0);
handles.minlimit=cell(0);
handles.maxlimit=cell(0);
handles.minquery=cell(0);
handles.maxquery=cell(0);
handles.discretequery=cell(0);
handles.rowcolors=cell(0);
handles.ineqconstraints=cell(0);
handles.isselected=cell(0);
handles.isvisible=cell(0);
handles.ispointofinterest=cell(0);
handles.variablecolors=cell(0);
handles.preferences=cell(0);
handles.normalizepreferences=cell(0);
handles.isobjective=cell(0); % a special type of function that uses preferences/targets
handles.projectname='';
handles.rankingcolumn=cell(0);
handles.rowlabelcolumn=cell(0);
handles.roi=[]; %print region of interest;
handles.selectionmode='lasso'; %current selection mode: none, box, lasso, or point.
handles.zoommode='selection';
handles.axespositions=cell(0); %unused
handles.isnoise=cell(0);
handles.distname=cell(0);
handles.distparams=cell(0);
handles.modelqueue=cell(0); %surrogate models waiting to be fit.
handles.models=cell(0); %surrogate models that have finished fitting.
handles.axeslisteners={};
handles.lastsheet=-1;
handles.optimizerresults=struct([]);


raveroot = which('rave');
handles.raveroot=raveroot(1:end-6);

%initialize variables
handles.newgraphtype='blank';
handles.currentgraph=[];
handles.allgraphs=[];
handles.graphanalysis=[]; %same length as allgraphs, contains number of analysis for indicated graph.
handles.graphdataset=[]; %ditto for data sets.
handles.fakeax=[];
handles.fakerax=[]; %allgraphs, fakeax, and fakerax contain the handles to the outermost (biggest) axes for a graph. They are always dim=(1,1), so they dont need to be cells.
handles.allblockers=[];
handles.expblockers=[];
handles.expAblockers=[];
handles.activeindex=[];
handles.activegraph=[];
handles.activetype='';
handles.activetab='';
handles.activedir=[]; %the directory this project resides in.
handles.activesubgraph=[]; %for use with plot matrices. contains the index of a SINGLE selected sub-axes. To get all subaxes for a graph, use handles.subax{activeindex}(:,:);
handles.subax=cell(0);
handles.subfakeax=cell(0);
handles.subfakerax=cell(0);
handles.tempplots=[];
%handles.tabflexgrid=[];
handles.rotater=0;
handles.rasters=cell(0);
handles.grabbers=cell(0);
%handles.javacomps=[];
handles.textboxj=cell(0);
handles.textboxh=cell(0);
handles.Agrabbers=cell(0);
handles.putaway=[]; %index of graphs that are currently put away.
handles.graphnames=cell(0);
handles.projectname='';
handles.activesheet=1;
handles.sheet=[];
handles.optimizetabobjects=[]; %an annoying special case.
handles.tabsvisible=1;
handles.mouseoverhandles=[];
handles.mouseoverfunctions=[];
handles.mouseoverdata={[]};
handles.isjavaworkspaceobject=false(0);

handles.lasta=1; %analysis of the last graph that was clicked
handles.lastd=1; %dataset of the last graph that was clicked

%intitialize "udata" for draw tab:
handles.draw.textbg=[1 1 .8]; %post-it yellow
handles.draw.edittextmode=0;%if 1, process drawtab callbacks on current text box.
handles.draw.fontname=handles.prefs.fonts.textbox;
handles.draw.fontstyle=4; %plain by default
handles.draw.fontsize=14;
handles.draw.showborder=1;
handles.draw.markercolor=[0 .5 1];
handles.draw.markersize=2;

%save last export config for easy exporting:
handles.lastexport.scale=10;
handles.lastexport.antialias='none';
handles.lastexport.filetype='.png';

%maintable stuff:
handles.tablemode=0; %true when table is visible.
handles.maintable.undos=cell(50,1); %history of table changes, used to undo.
handles.maintable.redos=cell(50,1); %for updates that have been undone.
handles.maintable.x=cell(0); %visible columns for each data set.
handles.maintable.colwidths=cell(0);
handles.maintable.wasdragged=0; %draggings sets this to 1 so mousereleasecallback knows not to select column.
handles.maintable.colorrows=1; %use row colors?
handles.maintable.shadehidden=1; %shade hidden rows?
handles.maintable.allowedits=1;
handles.maintable.allowselection=1;
handles.datasetupdatespending=cell(0);
handles.analysisupdatespending=cell(0);
%handles.maintableupdatespending=cell(0); %deprecated
handles.tablemodelupdatespending=cell(0);

handles.maintable.d=0;
handles.maintable.a=0;
handles.maintable.ignoreupdates=false;

handles.helproot='http://www.rave.gatech.edu/help/index.php?title=';
