function raveprefs=ravemakedefaultprefs
%Spits out a structure of the default rave preferences.
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2012 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

raveprefs.colors.tabbg= [1 1 1];
raveprefs.colors.tabfg= [0.5 0.5 0.5];
raveprefs.colors.wsbg= [1 1 1];
raveprefs.colors.wsgrid= [0.8 0.8 1];
raveprefs.colors.frame= [0.89 0.89 0.89];
raveprefs.colors.title= [0.4 0.4 0.4];
raveprefs.colors.text= [0.3 0.6 0.8];
raveprefs.colors.texttint= [0.6 0.8 1];
raveprefs.colors.buttonbg=get(0,'defaultuicontrolbackgroundcolor');
raveprefs.colors.togglebuttonbg= [0.875 0.855 0.815];
raveprefs.colors.constraint= [1 0 0];
raveprefs.colors.textbox= [0 0 0];
raveprefs.colors.edgecolor=[.2 .2 .2];
raveprefs.colors.maintable.text=[0 0 0];
raveprefs.colors.maintable.background=[1 1 1];
raveprefs.colors.maintable.shaded=[200 200 200]/255;
raveprefs.colors.maintable.selected=[154 202 250]/255;
raveprefs.colors.maintable.selectedshaded=[112 165 228]/255;
raveprefs.colors.maintable.grid=[.8 .8 .8];
raveprefs.colors.axes{1}=[.6 .6 .6;1 1 1;0.9 0.9 0.9;0.8 0.8 0.8;0 0 0]; %foreground ; background ; light grid ; strong grid ; text
raveprefs.colors.axes{2}=[0 0 0;.753 .753 .753;0.82 0.82 0.82;0.90 0.90 0.90;0 0 0];
raveprefs.colors.axes{3}=[0 0 0;.502 .502 .502;0.6 0.6 0.6;0.7 0.7 0.7;0 0 0];
raveprefs.colors.axes{4}=[.7 .7 .7;0 0 0;.2 .2 .2;.3 .3 .3;.7 .7 .7];
raveprefs.colors.selectionhighlight=[204 0 255]/255;   %--> light blue [0.47451 0.83922 0.99216];
raveprefs.colors.mouseoverhighlight=[144 75 244]/255;
raveprefs.colors.filtered=[.8 .8 .8];
raveprefs.colors.optfeasible=[90 163 255;42 63 156]/255;
raveprefs.colors.optinfeasible=[204 26 56;80 1 6]/255;
raveprefs.colors.optoptimal=[186 254 31;119 173 1]/255;
raveprefs.colors.opthistory=[.7 .7 .7;.5 .5 .5];
raveprefs.selectionthickness=2;
raveprefs.fonts.textbox= 'Verdana';
raveprefs.fonts.title= 'Magneto';
raveprefs.fonts.titlescale= 1;
raveprefs.fonts.tab= 'TektonPro-Bold';
raveprefs.fonts.tabscale= 1.1;
raveprefs.fonts.graph='Arial';
raveprefs.fonts.graphsize=10;
raveprefs.fonts.tick='Arial';
raveprefs.fonts.ticksize=10;
raveprefs.fonts.matrixsize=8;
raveprefs.fonts.graphtitle='Arial';
raveprefs.fonts.graphtitlesize=14;
%raveprefs.fonts.graphwidths=[1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 5 2 4 9 6 11 9 2 4 4 6 8 2 4 2 5 7 7 7 7 7 7 7 7 7 7 2 2 7 8 7 6 13 10 8 8 8 8 7 9 8 2 6 9 7 10 8 9 8 9 8 8 8 8 10 14 8 8 8 3 5 3 6 8 3 6 6 6 6 6 5 6 6 2 4 6 2 10 6 6 6 6 4 6 4 6 6 10 6 6 6 4 2 4 8 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1];
raveprefs.defaultdir= 'C:\Documents and Settings\yourname\My Documents\MATLAB\ravefiles\';
raveprefs.automovemode= 0;
raveprefs.wswidth= 5376;
raveprefs.wsheight= 3360;
raveprefs.snaptogrid= 1;
raveprefs.colwidth= 75;
raveprefs.gridmode= 3;
raveprefs.gridsize= 96;
raveprefs.alwaysrasterize= 0;
raveprefs.interpreter= 'none';
raveprefs.defaultvariablecolors= 'accel';
raveprefs.annotationcolor= [0 0 1];
%white to green:
raveprefs.colormap1=[0.964705882352941 0.937254901960784 0.968627450980392;0.741176470588235 0.788235294117647 0.882352941176471;0.403921568627451 0.662745098039216 0.811764705882353;0.109803921568627 0.564705882352941 0.6;0.00392156862745098 0.423529411764706 0.349019607843137];
%IEEE black purple yellow white
raveprefs.colormap1=[0 0 0;0.15 0.15 0.5;0.30 0.15 0.75;0.6 0.2 0.5;1 0.25 0.15;0.9 0.75 0.1;0.9 0.9 0.5;1 1 1];
%Red to green:
raveprefs.colormap2=[0.843137254901961 0.0980392156862745 0.109803921568627;0.992156862745098 0.682352941176471 0.380392156862745;1 1 0.749019607843137;0.650980392156863 0.850980392156863 0.415686274509804;0.101960784313725 0.588235294117647 0.254901960784314];
%Rainbow:
raveprefs.colormap3=[152 67 140;70 120 183;150 209 45;244 222 11;253 160 2;250 20 9]./255;

raveprefs.defaultcolormap=15;
raveprefs.defaultrowcolor= 2;
raveprefs.rowcolors=[241 76 112;70 120 183;150 209 45;244 222 11;253 160 2;107 144 148;150 90 162;74 179 141;184 70 71;184 133 70]./255;

raveprefs.barcolors= [0.454901960784314 0.450980392156863 0.709803921568627;0.545098039215686 0.63921568627451 0.325490196078431;0.741176470588235 0.615686274509804 0.235294117647059;0.670588235294118 0.294117647058824 0.294117647058824;0.63921568627451 0.325490196078431 0.576470588235294;0.658823529411765 0.611764705882353 0.858823529411765;0.796078431372549 0.858823529411765 0.611764705882353;0.890196078431373 0.796078431372549 0.580392156862745;0.890196078431373 0.580392156862745 0.607843137254902;0.858823529411765 0.611764705882353 0.831372549019608;0.611764705882353 0.611764705882353 0.858823529411765;0.705882352941177 0.8 0.415686274509804;0.890196078431373 0.729411764705882 0.329411764705882;0.831372549019608 0.388235294117647 0.419607843137255;0.8 0.423529411764706 0.737254901960784;0.301960784313725 0.333333333333333 0.52156862745098;0.392156862745098 0.470588235294118 0.227450980392157;0.549019607843137 0.427450980392157 0.203921568627451;0.52156862745098 0.235294117647059 0.235294117647059;0.490196078431373 0.262745098039216 0.454901960784314];
raveprefs.linecolors= [0.454901960784314 0.450980392156863 0.709803921568627;0.545098039215686 0.63921568627451 0.325490196078431;0.741176470588235 0.615686274509804 0.235294117647059;0.670588235294118 0.294117647058824 0.294117647058824;0.63921568627451 0.325490196078431 0.576470588235294;0.658823529411765 0.611764705882353 0.858823529411765;0.796078431372549 0.858823529411765 0.611764705882353;0.890196078431373 0.796078431372549 0.580392156862745;0.890196078431373 0.580392156862745 0.607843137254902;0.858823529411765 0.611764705882353 0.831372549019608;0.611764705882353 0.611764705882353 0.858823529411765;0.705882352941177 0.8 0.415686274509804;0.890196078431373 0.729411764705882 0.329411764705882;0.831372549019608 0.388235294117647 0.419607843137255;0.8 0.423529411764706 0.737254901960784;0.301960784313725 0.333333333333333 0.52156862745098;0.392156862745098 0.470588235294118 0.227450980392157;0.549019607843137 0.427450980392157 0.203921568627451;0.52156862745098 0.235294117647059 0.235294117647059;0.490196078431373 0.262745098039216 0.454901960784314];

raveprefs.alwaysupdate= 1;
raveprefs.startintablemode = 0;
raveprefs.isportable=0; %true if installed to usb drive.
raveprefs.monitorpositions=get(0,'MonitorPositions');

raveprefs.animation.animation=0;
raveprefs.animation.format='gif';
raveprefs.animation.loop=inf;
raveprefs.animation.realtime=0;
raveprefs.animation.fps=10;
raveprefs.animation.quality=100;
raveprefs.animation.compression='None';
raveprefs.animation.showinfo=1;
raveprefs.animation.infofont='Arial';
raveprefs.animation.infofontsize=12;
raveprefs.animation.infolocation='ne';
raveprefs.animation.infocolor=[0 0 0];
raveprefs.animation.pause=0; %pause between iterations;
raveprefs.animation.markersize=10;
raveprefs.animation.linewidth=1;
raveprefs.animation.updateanalysis=0;


raveprefs.dontchangemylaf=true;
raveprefs.gpgpu= 0;
raveprefs.gpusyntax= 'jacket';
raveprefs.logicaltrue= 'On';
raveprefs.logicalfalse= 'Off';
raveprefs.sendstringsasstrings= 1;
raveprefs.tabscale= 1;
raveprefs.cellcarrier= 'verizon';
raveprefs.cellnumber= '0000000000';
raveprefs.autoselectbest= 1;
raveprefs.matrixspacing= 2;
raveprefs.profilerhspacing= 0;
raveprefs.profilervspacing= 0;
raveprefs.constraintgridsize= 80;
raveprefs.setxdialswhensingleselected= 1;
raveprefs.preferredposition= [0 0 600 600];
raveprefs.useglobalfilters=true;
raveprefs.isresizable=true;
raveprefs.pagecontrollocation='SE';
raveprefs.explorerlocation='SE';
raveprefs.filteredselectable=false;
raveprefs.keepalloptimizerresults=true;
raveprefs.processmouseovers=true;
raveprefs.mouseoverdelay=0.15;
raveprefs.checkforupdates=true;
raveprefs.currentversion=0;
raveprefs.autodetectlogicalvars=false;
raveprefs.optmarkersize=6;

raveprefs.wvisual='';
raveprefs.xvisual='';

%alternate directories to look for rave plugins:
raveprefs.altgraphicsdir={''};
raveprefs.altoptimizerssdir={''};
raveprefs.altmodelsdir={''};
raveprefs.altobjectivesdir={''};
raveprefs.altexploremethodsdir={''};

%model fit reports:
raveprefs.fitreport.fitcolor=[0 143 239]./255;
raveprefs.fitreport.valcolor=[0 186 56]./255;
raveprefs.fitreport.testcolor=[237 28 36]./255;
raveprefs.fitreport.fitmarker={'marker','s','markersize',2,'markerfacecolor',[0 143 239]./255,'markeredgecolor','none'};
raveprefs.fitreport.valmarker={'marker','s','markersize',2,'markerfacecolor',[0 186 56]./255,'markeredgecolor','none'};
raveprefs.fitreport.testmarker={'marker','s','markersize',2,'markerfacecolor',[237 28 36]./255,'markeredgecolor','none'};
raveprefs.fitreport.font={'fontname','times new roman','fontsize',10};


