function managetab(src,eventdata)
%
% RAVE Rapid Analysis and Visualization Environment
% Copyright (C) 2011 Georgia Tech Research Corporation
% ALL RIGHTS RESERVED
%
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; version 2
% of the License.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.

ravechangetab(src,[]);
handles=guidata(src);
set(handles.infobar,'string','');
handles.activetab='manage';
guidata(src,handles);

%move front tabs to front if necessary
set(handles.fronttabaxes,'position',handles.fronttabposition)
set(handles.backtabaxes,'position',handles.backtabposition)
[x,y,v]=calculatetabprofile(handles.backtabprofile,.1,1,0); %#ok<NASGU>
set(handles.backtablines,'xdata',x,'ydata',y);
[x,y,v]=calculatetabprofile(handles.fronttabprofile,.1,1,1); %#ok<NASGU>
set(handles.fronttablines,'xdata',x,'ydata',y)
set(handles.infobar,'string','');

origin=get(handles.tabaxes,'position');

%% text headers
projecttext=text(.15-.10317,.95*1.0317-.0317,'Project','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
graphtext=text(.15-.10317,.708,'Workspace','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);
loadtext=text(.15-.10317,.34,'Save & Load','horizontalalignment','left','backgroundcolor',handles.colors.tabbg,...
    'parent',handles.tabaxes,'fontsize',18*handles.prefs.fonts.titlescale,'fontname',handles.prefs.fonts.title,'color',handles.colors.title);

%% uicontrols
%project
managedatabutton=uicontrol('position',[origin(1)+55 origin(2)+550 170 30],'style','pushbutton',...
    'string','Manage Data Sets','callback',@ravemanagedata,...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'busyaction','cancel');
manageanalysesbutton=uicontrol('position',[origin(1)+55 origin(2)+510 170 30],'style','pushbutton',...
    'string','Manage Analyses','callback',@ravemanageanalyses,...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig);
resizewsbutton=uicontrol('position',[origin(1)+55 origin(2)+470 170 30],'style','pushbutton',...
    'string','Resize Workspace',...
    'fontname','arial narrow','fontsize',12,'parent',handles.fig,'enable','off','visible','off');

%make java buttons:
buttonfont=java.awt.Font('Arial Narrow',0,14); %name, style, size
c=handles.colors.buttonbg;
buttoncolor=java.awt.Color(c(1),c(2),c(3));
marg=java.awt.Insets(5,5,5,5);

%new graph button:
j=javax.swing.JButton;
myIcon = which('newgraphicon.gif');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Create New...');
j.setHorizontalAlignment(2); %left align
j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@newgraphbutton_callback,handles.fig})
[junk newgraphbutton]=javacomponent(j,[origin(1)+25 origin(2)+330+70 105 30],handles.fig);

%
% %link graph button:
% % linkgraphbutton=uicontrol('position',[origin(1)+55 origin(2)+270 100 30],'style','pushbutton',...
% %     'string','Link','backgroundcolor',handles.colors.buttonbg,...
% %     'fontname','arial narrow','fontsize',12,'callback',@ravelinkgraph,'parent',handles.fig);
% j=javax.swing.JButton;
% myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/tool_plot_linked.png');
% iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
% j.setIcon(javax.swing.ImageIcon(iconImage));
% j.setText('Link Graphs');
% j.setHorizontalAlignment(2); %left align
% j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
% j.setFont(buttonfont);
% j.setBackground(buttoncolor);
% j.setEnabled(false);
% h=handle(j,'callbackproperties');
% set(h,'ActionPerformedCallback',{@linkgraphbutton_callback,handles.fig})
% [junk linkgraphbutton]=javacomponent(j,[origin(1)+25 origin(2)+250+70 100 30],handles.fig);
%

%
% %movegraphbutton
% % movegraphbutton=uicontrol('position',[origin(1)+55 origin(2)+310 100 30],'style','pushbutton',...
% %     'string','Move/Resize','backgroundcolor',handles.colors.buttonbg,...
% %     'fontname','arial narrow','fontsize',12,'parent',handles.fig);
% j=javax.swing.JButton;
% myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/tool_arrow_dbl.png');
% iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
% j.setIcon(javax.swing.ImageIcon(iconImage));
% j.setText('Move/Resize');
% j.setHorizontalAlignment(2); %left align
% j.setMargin(java.awt.Insets(5,2,5,2)); %top left bottom right
% j.setFont(buttonfont);
% j.setBackground(buttoncolor);
% j.setEnabled(false);
% h=handle(j,'callbackproperties');
% set(h,'ActionPerformedCallback',{@movegraphbutton_callback,handles.fig})
% [junk movegraphbutton]=javacomponent(j,[origin(1)+25 origin(2)+290+70 100 30],handles.fig);

%duplicate graph
% duplicategraphbutton=uicontrol('position',[origin(1)+55 origin(2)+230 100 30],'style','pushbutton',...
%     'string','Duplicate','backgroundcolor',handles.colors.buttonbg,...
%     'fontname','arial narrow','fontsize',12,'parent',handles.fig);
j=javax.swing.JButton;
myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/HDF_VGroup.gif');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Duplicate');
j.setHorizontalAlignment(0); %left align
j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
%j.setEnabled(false);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@duplicategraphbutton_callback,handles.fig})
[jduplicategraphbutton duplicategraphbutton]=javacomponent(j,[origin(1)+25 origin(2)+210+70+80 105 30],handles.fig);

%delete graph button
% deletegraphbutton=uicontrol('position',[origin(1)+55 origin(2)+190 100 30],'style','pushbutton',...
%     'string','Delete','backgroundcolor',handles.colors.buttonbg,...
%     'fontname','arial narrow','fontsize',12,'callback',{@ravedeletegraph,1},'parent',handles.fig);
j=javax.swing.JButton;
myIcon = which('trashicon.gif');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Delete');
j.setHorizontalAlignment(0); %left align
j.setMargin(java.awt.Insets(5,5,5,10)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@deletegraphbutton_callback,handles.fig})
[jdeletegraphbutton deletegraphbutton]=javacomponent(j,[origin(1)+25 origin(2)+170+70+80 105 30],handles.fig);

%2nd column
% putawaybutton=uicontrol('position',[origin(1)+175 origin(2)+350 100 30],'style','pushbutton',...
%     'string','Put Away','backgroundcolor',handles.colors.buttonbg,...
%     'fontname','arial narrow','fontsize',12,'parent',handles.fig);
j=javax.swing.JButton;
myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/HDF_gridfieldset.gif');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Put Away');
j.setHorizontalAlignment(0); %left align
j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
j.setEnabled(true);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@putawaybutton_callback,handles.fig})
[jputawaybutton putawaybutton]=javacomponent(j,[origin(1)+145 origin(2)+330+70 100 30],handles.fig);

% restorebutton=uicontrol('position',[origin(1)+175 origin(2)+310 100 30],'style','pushbutton',...
%     'string','Restore','backgroundcolor',handles.colors.buttonbg,...
%     'fontname','arial narrow','fontsize',12,'parent',handles.fig);
j=javax.swing.JButton;
myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/file_open.png');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Restore');
j.setHorizontalAlignment(0); %left align
j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
j.setEnabled(true);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@restorebutton_callback,handles.fig})
[jrestorebutton restorebutton]=javacomponent(j,[origin(1)+145 origin(2)+290+70 100 30],handles.fig);



%load & save
j=javax.swing.JButton;
myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/file_save.png');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Save Project to File');
j.setHorizontalAlignment(0); %left align
j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@savebutton_callback,handles.fig})
[jsavebutton savebutton]=javacomponent(j,[origin(1)+55 origin(2)+95+76 170 30],handles.fig);

j=javax.swing.JButton;
myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/file_open.png');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Load a Project from File');
j.setHorizontalAlignment(0); %left align
j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@loadbutton_callback,handles.fig})
[jloadbutton loadbutton]=javacomponent(j,[origin(1)+55 origin(2)+55+76 170 30],handles.fig);

j=javax.swing.JButton;
myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/HDF_SDS.gif');
iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
j.setIcon(javax.swing.ImageIcon(iconImage));
j.setText('Save Metadata');
j.setHorizontalAlignment(0); %left align
j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
j.setFont(buttonfont);
j.setBackground(buttoncolor);
set(handle(j,'callbackproperties'),'ActionPerformedCallback',{@savembutton_callback,handles.fig})
[jsavembutton savembutton]=javacomponent(j,[origin(1)+55 origin(2)+95-20 170 30],handles.fig);
%
% j=javax.swing.JButton;
% myIcon = fullfile(matlabroot,'/toolbox/matlab/icons/file_open.png');
% iconImage = java.awt.Toolkit.getDefaultToolkit.createImage(myIcon);
% j.setIcon(javax.swing.ImageIcon(iconImage));
% j.setText('Load Metadata');
% j.setHorizontalAlignment(0); %left align
% j.setMargin(java.awt.Insets(5,5,5,5)); %top left bottom right
% j.setFont(buttonfont);
% j.setBackground(buttoncolor);
% j.setEnabled(false);
% h=handle(j,'callbackproperties');
% set(h,'ActionPerformedCallback',{@loadmbutton_callback,handles.fig})
% [jloadmbutton loadmbutton]=javacomponent(j,[origin(1)+55 origin(2)+55-20 170 30],handles.fig);

handles.tabobjects=[projecttext graphtext managedatabutton...
    resizewsbutton newgraphbutton ...
    duplicategraphbutton loadtext loadbutton savebutton deletegraphbutton...
    putawaybutton restorebutton manageanalysesbutton savembutton];

%handles.javacomps=[jduplicategraphbutton jdeletegraphbutton jputawaybutton jrestorebutton...
%    jsavebutton jloadbutton jsavembutton];


handles.activetab='manage';
ravescaletabs

%disable buttons if no data is loaded
if numel(handles.datasetnames)==0
    set(manageanalysesbutton,'enable','off')
    set(get(newgraphbutton,'javapeer'),'Enable',0)
    set(get(duplicategraphbutton,'javapeer'),'Enable',0)
    set(get(savebutton,'javapeer'),'Enable',0)
    set(get(deletegraphbutton,'javapeer'),'Enable',0)
    set(get(putawaybutton,'javapeer'),'Enable',0)
    set(get(restorebutton,'javapeer'),'Enable',0)
end

if numel(handles.allgraphs(ishandle(handles.allgraphs)))==0
    set(get(duplicategraphbutton,'javapeer'),'Enable',0)
    set(get(deletegraphbutton,'javapeer'),'Enable',0)
    set(get(putawaybutton,'javapeer'),'Enable',0)
end


if isempty(handles.putaway)
    set(get(restorebutton,'javapeer'),'Enable',0)
end



guidata(src,handles);


%% here be callbacks:

function ravemanagedata(src,ev)
%load handles
handles=guidata(src);

%do gui;
set(0,'userdata',get(handles.fig,'position'));
hhh=managedatagui;
uiwait(hhh)

% if all(strcmp(get(0,'userdata'),'cancel'))
%     return;
% else
handles=get(0,'userdata');
guidata(handles.fig,handles);
%end

if ~isempty(handles.alldata)
    set(handles.alltabs,'hittest','on'); %allow use of other tabs.
end


%refresh managetab
managetab(handles.fig,[]);

%tell to make a new graph:
if handles.tablemode
    ravedisplaymaintable(handles.fig,[]);
else
    if ~isempty(handles.alldata) && isempty(handles.allgraphs)
        set(handles.infobar,'string','Click "Create New" to make a graph.')
    end
end

function ravemanageanalyses(src,ev)

%load handles
handles=guidata(src);

%do gui;
set(0,'userdata',get(handles.fig,'position'));
hhh=manageanalysesgui;
uiwait(hhh)


function savebutton_callback(jsrc,jev,src) %#ok<INUSL>
set(0,'userdata','');
ravesavestate(src,[]);

function loadbutton_callback(jsrc,jev,src) %#ok<INUSL>
raveopenstate(src,[]);

function newgraphbutton_callback(jsrc,jev,src) %#ok<INUSL>
ravenewgraph(src,[]);

function duplicategraphbutton_callback(jsrc,jev,src)
raveduplicategraph(src,[]);



function putawaybutton_callback(jsrc,jev,src) %#ok<INUSL>
raveputaway(src,[]);


function restorebutton_callback(jsrc,jev,src) %#ok<INUSL>
raverestoregraph(src,[]);

function deletegraphbutton_callback(jsrc,jev,src)  %#ok<INUSL>
ravedeletegraph(src,[],1);

function savembutton_callback(jsrc,jev,src) %#ok<INUSL>
ravesavemetadata(src,[]);

function loadmbutton_callback(jsrc,jev,src) %#ok<INUSL>
raveloadmetadata(src,[]);


